# all files / ol/format/ kmlformat.js

93.49% Statements 891/953
76.23% Branches 279/366
97.22% Functions 70/72
93.49% Lines 891/953

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    271
    272
    273
    274
    275
    276
    277
    278
    279
    280
    281
    282
    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293
    294
    295
    296
    297
    298
    299
    300
    301
    302
    303
    304
    305
    306
    307
    308
    309
    310
    311
    312
    313
    314
    315
    316
    317
    318
    319
    320
    321
    322
    323
    324
    325
    326
    327
    328
    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343
    344
    345
    346
    347
    348
    349
    350
    351
    352
    353
    354
    355
    356
    357
    358
    359
    360
    361
    362
    363
    364
    365
    366
    367
    368
    369
    370
    371
    372
    373
    374
    375
    376
    377
    378
    379
    380
    381
    382
    383
    384
    385
    386
    387
    388
    389
    390
    391
    392
    393
    394
    395
    396
    397
    398
    399
    400
    401
    402
    403
    404
    405
    406
    407
    408
    409
    410
    411
    412
    413
    414
    415
    416
    417
    418
    419
    420
    421
    422
    423
    424
    425
    426
    427
    428
    429
    430
    431
    432
    433
    434
    435
    436
    437
    438
    439
    440
    441
    442
    443
    444
    445
    446
    447
    448
    449
    450
    451
    452
    453
    454
    455
    456
    457
    458
    459
    460
    461
    462
    463
    464
    465
    466
    467
    468
    469
    470
    471
    472
    473
    474
    475
    476
    477
    478
    479
    480
    481
    482
    483
    484
    485
    486
    487
    488
    489
    490
    491
    492
    493
    494
    495
    496
    497
    498
    499
    500
    501
    502
    503
    504
    505
    506
    507
    508
    509
    510
    511
    512
    513
    514
    515
    516
    517
    518
    519
    520
    521
    522
    523
    524
    525
    526
    527
    528
    529
    530
    531
    532
    533
    534
    535
    536
    537
    538
    539
    540
    541
    542
    543
    544
    545
    546
    547
    548
    549
    550
    551
    552
    553
    554
    555
    556
    557
    558
    559
    560
    561
    562
    563
    564
    565
    566
    567
    568
    569
    570
    571
    572
    573
    574
    575
    576
    577
    578
    579
    580
    581
    582
    583
    584
    585
    586
    587
    588
    589
    590
    591
    592
    593
    594
    595
    596
    597
    598
    599
    600
    601
    602
    603
    604
    605
    606
    607
    608
    609
    610
    611
    612
    613
    614
    615
    616
    617
    618
    619
    620
    621
    622
    623
    624
    625
    626
    627
    628
    629
    630
    631
    632
    633
    634
    635
    636
    637
    638
    639
    640
    641
    642
    643
    644
    645
    646
    647
    648
    649
    650
    651
    652
    653
    654
    655
    656
    657
    658
    659
    660
    661
    662
    663
    664
    665
    666
    667
    668
    669
    670
    671
    672
    673
    674
    675
    676
    677
    678
    679
    680
    681
    682
    683
    684
    685
    686
    687
    688
    689
    690
    691
    692
    693
    694
    695
    696
    697
    698
    699
    700
    701
    702
    703
    704
    705
    706
    707
    708
    709
    710
    711
    712
    713
    714
    715
    716
    717
    718
    719
    720
    721
    722
    723
    724
    725
    726
    727
    728
    729
    730
    731
    732
    733
    734
    735
    736
    737
    738
    739
    740
    741
    742
    743
    744
    745
    746
    747
    748
    749
    750
    751
    752
    753
    754
    755
    756
    757
    758
    759
    760
    761
    762
    763
    764
    765
    766
    767
    768
    769
    770
    771
    772
    773
    774
    775
    776
    777
    778
    779
    780
    781
    782
    783
    784
    785
    786
    787
    788
    789
    790
    791
    792
    793
    794
    795
    796
    797
    798
    799
    800
    801
    802
    803
    804
    805
    806
    807
    808
    809
    810
    811
    812
    813
    814
    815
    816
    817
    818
    819
    820
    821
    822
    823
    824
    825
    826
    827
    828
    829
    830
    831
    832
    833
    834
    835
    836
    837
    838
    839
    840
    841
    842
    843
    844
    845
    846
    847
    848
    849
    850
    851
    852
    853
    854
    855
    856
    857
    858
    859
    860
    861
    862
    863
    864
    865
    866
    867
    868
    869
    870
    871
    872
    873
    874
    875
    876
    877
    878
    879
    880
    881
    882
    883
    884
    885
    886
    887
    888
    889
    890
    891
    892
    893
    894
    895
    896
    897
    898
    899
    900
    901
    902
    903
    904
    905
    906
    907
    908
    909
    910
    911
    912
    913
    914
    915
    916
    917
    918
    919
    920
    921
    922
    923
    924
    925
    926
    927
    928
    929
    930
    931
    932
    933
    934
    935
    936
    937
    938
    939
    940
    941
    942
    943
    944
    945
    946
    947
    948
    949
    950
    951
    952
    953
    954
    955
    956
    957
    958
    959
    960
    961
    962
    963
    964
    965
    966
    967
    968
    969
    970
    971
    972
    973
    974
    975
    976
    977
    978
    979
    980
    981
    982
    983
    984
    985
    986
    987
    988
    989
    990
    991
    992
    993
    994
    995
    996
    997
    998
    999
    1000
    1001
    1002
    1003
    1004
    1005
    1006
    1007
    1008
    1009
    1010
    1011
    1012
    1013
    1014
    1015
    1016
    1017
    1018
    1019
    1020
    1021
    1022
    1023
    1024
    1025
    1026
    1027
    1028
    1029
    1030
    1031
    1032
    1033
    1034
    1035
    1036
    1037
    1038
    1039
    1040
    1041
    1042
    1043
    1044
    1045
    1046
    1047
    1048
    1049
    1050
    1051
    1052
    1053
    1054
    1055
    1056
    1057
    1058
    1059
    1060
    1061
    1062
    1063
    1064
    1065
    1066
    1067
    1068
    1069
    1070
    1071
    1072
    1073
    1074
    1075
    1076
    1077
    1078
    1079
    1080
    1081
    1082
    1083
    1084
    1085
    1086
    1087
    1088
    1089
    1090
    1091
    1092
    1093
    1094
    1095
    1096
    1097
    1098
    1099
    1100
    1101
    1102
    1103
    1104
    1105
    1106
    1107
    1108
    1109
    1110
    1111
    1112
    1113
    1114
    1115
    1116
    1117
    1118
    1119
    1120
    1121
    1122
    1123
    1124
    1125
    1126
    1127
    1128
    1129
    1130
    1131
    1132
    1133
    1134
    1135
    1136
    1137
    1138
    1139
    1140
    1141
    1142
    1143
    1144
    1145
    1146
    1147
    1148
    1149
    1150
    1151
    1152
    1153
    1154
    1155
    1156
    1157
    1158
    1159
    1160
    1161
    1162
    1163
    1164
    1165
    1166
    1167
    1168
    1169
    1170
    1171
    1172
    1173
    1174
    1175
    1176
    1177
    1178
    1179
    1180
    1181
    1182
    1183
    1184
    1185
    1186
    1187
    1188
    1189
    1190
    1191
    1192
    1193
    1194
    1195
    1196
    1197
    1198
    1199
    1200
    1201
    1202
    1203
    1204
    1205
    1206
    1207
    1208
    1209
    1210
    1211
    1212
    1213
    1214
    1215
    1216
    1217
    1218
    1219
    1220
    1221
    1222
    1223
    1224
    1225
    1226
    1227
    1228
    1229
    1230
    1231
    1232
    1233
    1234
    1235
    1236
    1237
    1238
    1239
    1240
    1241
    1242
    1243
    1244
    1245
    1246
    1247
    1248
    1249
    1250
    1251
    1252
    1253
    1254
    1255
    1256
    1257
    1258
    1259
    1260
    1261
    1262
    1263
    1264
    1265
    1266
    1267
    1268
    1269
    1270
    1271
    1272
    1273
    1274
    1275
    1276
    1277
    1278
    1279
    1280
    1281
    1282
    1283
    1284
    1285
    1286
    1287
    1288
    1289
    1290
    1291
    1292
    1293
    1294
    1295
    1296
    1297
    1298
    1299
    1300
    1301
    1302
    1303
    1304
    1305
    1306
    1307
    1308
    1309
    1310
    1311
    1312
    1313
    1314
    1315
    1316
    1317
    1318
    1319
    1320
    1321
    1322
    1323
    1324
    1325
    1326
    1327
    1328
    1329
    1330
    1331
    1332
    1333
    1334
    1335
    1336
    1337
    1338
    1339
    1340
    1341
    1342
    1343
    1344
    1345
    1346
    1347
    1348
    1349
    1350
    1351
    1352
    1353
    1354
    1355
    1356
    1357
    1358
    1359
    1360
    1361
    1362
    1363
    1364
    1365
    1366
    1367
    1368
    1369
    1370
    1371
    1372
    1373
    1374
    1375
    1376
    1377
    1378
    1379
    1380
    1381
    1382
    1383
    1384
    1385
    1386
    1387
    1388
    1389
    1390
    1391
    1392
    1393
    1394
    1395
    1396
    1397
    1398
    1399
    1400
    1401
    1402
    1403
    1404
    1405
    1406
    1407
    1408
    1409
    1410
    1411
    1412
    1413
    1414
    1415
    1416
    1417
    1418
    1419
    1420
    1421
    1422
    1423
    1424
    1425
    1426
    1427
    1428
    1429
    1430
    1431
    1432
    1433
    1434
    1435
    1436
    1437
    1438
    1439
    1440
    1441
    1442
    1443
    1444
    1445
    1446
    1447
    1448
    1449
    1450
    1451
    1452
    1453
    1454
    1455
    1456
    1457
    1458
    1459
    1460
    1461
    1462
    1463
    1464
    1465
    1466
    1467
    1468
    1469
    1470
    1471
    1472
    1473
    1474
    1475
    1476
    1477
    1478
    1479
    1480
    1481
    1482
    1483
    1484
    1485
    1486
    1487
    1488
    1489
    1490
    1491
    1492
    1493
    1494
    1495
    1496
    1497
    1498
    1499
    1500
    1501
    1502
    1503
    1504
    1505
    1506
    1507
    1508
    1509
    1510
    1511
    1512
    1513
    1514
    1515
    1516
    1517
    1518
    1519
    1520
    1521
    1522
    1523
    1524
    1525
    1526
    1527
    1528
    1529
    1530
    1531
    1532
    1533
    1534
    1535
    1536
    1537
    1538
    1539
    1540
    1541
    1542
    1543
    1544
    1545
    1546
    1547
    1548
    1549
    1550
    1551
    1552
    1553
    1554
    1555
    1556
    1557
    1558
    1559
    1560
    1561
    1562
    1563
    1564
    1565
    1566
    1567
    1568
    1569
    1570
    1571
    1572
    1573
    1574
    1575
    1576
    1577
    1578
    1579
    1580
    1581
    1582
    1583
    1584
    1585
    1586
    1587
    1588
    1589
    1590
    1591
    1592
    1593
    1594
    1595
    1596
    1597
    1598
    1599
    1600
    1601
    1602
    1603
    1604
    1605
    1606
    1607
    1608
    1609
    1610
    1611
    1612
    1613
    1614
    1615
    1616
    1617
    1618
    1619
    1620
    1621
    1622
    1623
    1624
    1625
    1626
    1627
    1628
    1629
    1630
    1631
    1632
    1633
    1634
    1635
    1636
    1637
    1638
    1639
    1640
    1641
    1642
    1643
    1644
    1645
    1646
    1647
    1648
    1649
    1650
    1651
    1652
    1653
    1654
    1655
    1656
    1657
    1658
    1659
    1660
    1661
    1662
    1663
    1664
    1665
    1666
    1667
    1668
    1669
    1670
    1671
    1672
    1673
    1674
    1675
    1676
    1677
    1678
    1679
    1680
    1681
    1682
    1683
    1684
    1685
    1686
    1687
    1688
    1689
    1690
    1691
    1692
    1693
    1694
    1695
    1696
    1697
    1698
    1699
    1700
    1701
    1702
    1703
    1704
    1705
    1706
    1707
    1708
    1709
    1710
    1711
    1712
    1713
    1714
    1715
    1716
    1717
    1718
    1719
    1720
    1721
    1722
    1723
    1724
    1725
    1726
    1727
    1728
    1729
    1730
    1731
    1732
    1733
    1734
    1735
    1736
    1737
    1738
    1739
    1740
    1741
    1742
    1743
    1744
    1745
    1746
    1747
    1748
    1749
    1750
    1751
    1752
    1753
    1754
    1755
    1756
    1757
    1758
    1759
    1760
    1761
    1762
    1763
    1764
    1765
    1766
    1767
    1768
    1769
    1770
    1771
    1772
    1773
    1774
    1775
    1776
    1777
    1778
    1779
    1780
    1781
    1782
    1783
    1784
    1785
    1786
    1787
    1788
    1789
    1790
    1791
    1792
    1793
    1794
    1795
    1796
    1797
    1798
    1799
    1800
    1801
    1802
    1803
    1804
    1805
    1806
    1807
    1808
    1809
    1810
    1811
    1812
    1813
    1814
    1815
    1816
    1817
    1818
    1819
    1820
    1821
    1822
    1823
    1824
    1825
    1826
    1827
    1828
    1829
    1830
    1831
    1832
    1833
    1834
    1835
    1836
    1837
    1838
    1839
    1840
    1841
    1842
    1843
    1844
    1845
    1846
    1847
    1848
    1849
    1850
    1851
    1852
    1853
    1854
    1855
    1856
    1857
    1858
    1859
    1860
    1861
    1862
    1863
    1864
    1865
    1866
    1867
    1868
    1869
    1870
    1871
    1872
    1873
    1874
    1875
    1876
    1877
    1878
    1879
    1880
    1881
    1882
    1883
    1884
    1885
    1886
    1887
    1888
    1889
    1890
    1891
    1892
    1893
    1894
    1895
    1896
    1897
    1898
    1899
    1900
    1901
    1902
    1903
    1904
    1905
    1906
    1907
    1908
    1909
    1910
    1911
    1912
    1913
    1914
    1915
    1916
    1917
    1918
    1919
    1920
    1921
    1922
    1923
    1924
    1925
    1926
    1927
    1928
    1929
    1930
    1931
    1932
    1933
    1934
    1935
    1936
    1937
    1938
    1939
    1940
    1941
    1942
    1943
    1944
    1945
    1946
    1947
    1948
    1949
    1950
    1951
    1952
    1953
    1954
    1955
    1956
    1957
    1958
    1959
    1960
    1961
    1962
    1963
    1964
    1965
    1966
    1967
    1968
    1969
    1970
    1971
    1972
    1973
    1974
    1975
    1976
    1977
    1978
    1979
    1980
    1981
    1982
    1983
    1984
    1985
    1986
    1987
    1988
    1989
    1990
    1991
    1992
    1993
    1994
    1995
    1996
    1997
    1998
    1999
    2000
    2001
    2002
    2003
    2004
    2005
    2006
    2007
    2008
    2009
    2010
    2011
    2012
    2013
    2014
    2015
    2016
    2017
    2018
    2019
    2020
    2021
    2022
    2023
    2024
    2025
    2026
    2027
    2028
    2029
    2030
    2031
    2032
    2033
    2034
    2035
    2036
    2037
    2038
    2039
    2040
    2041
    2042
    2043
    2044
    2045
    2046
    2047
    2048
    2049
    2050
    2051
    2052
    2053
    2054
    2055
    2056
    2057
    2058
    2059
    2060
    2061
    2062
    2063
    2064
    2065
    2066
    2067
    2068
    2069
    2070
    2071
    2072
    2073
    2074
    2075
    2076
    2077
    2078
    2079
    2080
    2081
    2082
    2083
    2084
    2085
    2086
    2087
    2088
    2089
    2090
    2091
    2092
    2093
    2094
    2095
    2096
    2097
    2098
    2099
    2100
    2101
    2102
    2103
    2104
    2105
    2106
    2107
    2108
    2109
    2110
    2111
    2112
    2113
    2114
    2115
    2116
    2117
    2118
    2119
    2120
    2121
    2122
    2123
    2124
    2125
    2126
    2127
    2128
    2129
    2130
    2131
    2132
    2133
    2134
    2135
    2136
    2137
    2138
    2139
    2140
    2141
    2142
    2143
    2144
    2145
    2146
    2147
    2148
    2149
    2150
    2151
    2152
    2153
    2154
    2155
    2156
    2157
    2158
    2159
    2160
    2161
    2162
    2163
    2164
    2165
    2166
    2167
    2168
    2169
    2170
    2171
    2172
    2173
    2174
    2175
    2176
    2177
    2178
    2179
    2180
    2181
    2182
    2183
    2184
    2185
    2186
    2187
    2188
    2189
    2190
    2191
    2192
    2193
    2194
    2195
    2196
    2197
    2198
    2199
    2200
    2201
    2202
    2203
    2204
    2205
    2206
    2207
    2208
    2209
    2210
    2211
    2212
    2213
    2214
    2215
    2216
    2217
    2218
    2219
    2220
    2221
    2222
    2223
    2224
    2225
    2226
    2227
    2228
    2229
    2230
    2231
    2232
    2233
    2234
    2235
    2236
    2237
    2238
    2239
    2240
    2241
    2242
    2243
    2244
    2245
    2246
    2247
    2248
    2249
    2250
    2251
    2252
    2253
    2254
    2255
    2256
    2257
    2258
    2259
    2260
    2261
    2262
    2263
    2264
    2265
    2266
    2267
    2268
    2269
    2270
    2271
    2272
    2273
    2274
    2275
    2276
    2277
    2278
    2279
    2280
    2281
    2282
    2283
    2284
    2285
    2286
    2287
    2288
    2289
    2290
    2291
    2292
    2293
    2294
    2295
    2296
    2297
    2298
    2299
    2300
    2301
    2302
    2303
    2304
    2305
    2306
    2307
    2308
    2309
    2310
    2311
    2312
    2313
    2314
    2315
    2316
    2317
    2318
    2319
    2320
    2321
    2322
    2323
    2324
    2325
    2326
    2327
    2328
    2329
    2330
    2331
    2332
    2333
    2334
    2335
    2336
    2337
    2338
    2339
    2340
    2341
    2342
    2343
    2344
    2345
    2346
    2347
    2348
    2349
    2350
    2351
    2352
    2353
    2354
    2355
    2356
    2357
    2358
    2359
    2360
    2361
    2362
    2363
    2364
    2365
    2366
    2367
    2368
    2369
    2370
    2371
    2372
    2373
    2374
    2375
    2376
    2377
    2378
    2379
    2380
    2381
    2382
    2383
    2384
    2385
    2386
    2387
    2388
    2389
    2390
    2391
    2392
    2393
    2394
    2395
    2396
    2397
    2398
    2399
    2400
    2401
    2402
    2403
    2404
    2405
    2406
    2407
    2408
    2409
    2410
    2411
    2412
    2413
    2414
    2415
    2416
    2417
    2418
    2419
    2420
    2421
    2422
    2423
    2424
    2425
    2426
    2427
    2428
    2429
    2430
    2431
    2432
    2433
    2434
    2435
    2436
    2437
    2438
    2439
    2440
    2441
    2442
    2443
    2444
    2445
    2446
    2447
    2448
    2449
    2450
    2451
    2452
    2453
    2454
    2455
    2456
    2457
    2458
    2459
    2460
    2461
    2462
    2463
    2464
    2465
    2466
    2467
    2468
    2469
    2470
    2471
    2472
    2473
    2474
    2475
    2476
    2477
    2478
    2479
    2480
    2481
    2482
    2483
    2484
    2485
    2486
    2487
    2488
    2489
    2490
    2491
    2492
    2493
    2494
    2495
    2496
    2497
    2498
    2499
    2500
    2501
    2502
    2503
    2504
    2505
    2506
    2507
    2508
    2509
    2510
    2511
    2512
    2513
    2514
    2515
    2516
    2517
    2518
    2519
    2520
    2521
    2522
    2523
    2524
    2525
    2526
    2527
    2528
    2529
    2530
    2531
    2532
    2533
    2534
    2535
    2536
    2537
    2538
    2539
    2540
    2541
    2542
    2543
    2544
    2545
    2546
    2547
    2548
    2549
    2550
    2551
    2552
    2553
    2554
    2555
    2556
    2557
    2558
    2559
    2560
    2561
    2562
    2563
    2564
    2565
    2566
    2567
    2568
    2569
    2570
    2571
    2572
    2573
    2574
    2575
    2576
    2577
    2578
    2579
    2580
    2581
    2582
    2583
    2584
    2585
    2586
    2587
    2588
    2589
    2590
    2591
    2592
    2593
    2594
    2595
    2596
    2597
    2598
    2599
    2600
    2601
    2602
    2603
    2604
    2605
    2606
    2607
    2608
    2609
    2610
    2611
    2612
    2613
    2614
    2615
    2616
    2617
    2618
    2619
    2620
    2621
    2622
    2623
    2624
    2625
    2626
    2627
    2628
    2629
    2630
    2631
    2632
    2633
    2634
    2635
    2636
    2637
    2638
    2639
    2640
    2641
    2642
    2643
    2644
    2645
    2646
    2647
    2648
    2649
    2650
    2651
    2652
    2653
    2654
    2655
    2656
    2657
    2658
    2659
    2660
    2661
    2662
    2663
    2664
    2665
    2666
    2667
    2668
    2669
    2670
    2671
    2672
    2673
    2674
    2675
    2676
    2677
    2678
    2679
    2680
    2681
    2682
    2683
    2684
    2685
    2686
    2687
    2688
    2689
    2690
    2691
    2692
    2693
    2694
    2695
    2696
    2697
    2698
    2699
    2700
    2701
    2702
    2703
    2704
    2705
    2706
    2707
    2708
    2709
    2710
    2711
    2712
    2713
    2714
    2715
    2716
    2717
    2718
    2719
    2720
    2721
    2722
    2723
    2724
    2725
    2726
    2727
    2728
    2729
    2730
    2731
    2732
    2733
    2734
    2735
    2736
    2737
    2738
    2739
    2740
    2741
    2742
    2743
    2744
    2745
    2746
    2747
    2748
    2749
    2750
    2751
    2752
    2753
    2754
    2755
    2756
    2757
    2758
    2759
    2760
    2761
    2762
    2763
    2764
    2765
    2766
    2767
    2768
    2769
    2770
    2771
    2772
    2773
    2774
    2775
    2776
    2777
    2778
    2779
    2780
    2781
    2782
    2783
    2784
    2785
    2786
    2787
    2788
    2789
    2790
    2791
    2792
    2793
    2794
    2795
    2796
    2797
    2798
    2799
    2800
    2801
    2802
    2803
    2804
    2805
    2806
    2807
    2808
    2809
    2810
    2811
    2812
    2813
    2814
    2815
    2816
    2817
    2818
    2819
    2820
    2821
    2822
    2823
    2824
    2825
    2826
    2827
    2828
    2829
    2830
    2831
    2832
    2833
    2834
    2835
    2836
    2837
    2838
    2839
    2840
    2841
    2842
    2843
    2844
    2845
    2846
    2847
    2848
    2849
    2850
    2851
    2852
    2853
    2854
    2855
    2856
    2857
    2858
    2859
    2860
    2861
    2862
    2863
    2864
    2865
    2866
    2867
    2868
    2869
    2870
    2871
    2872
    2873
    2874
    2875
    2876
    2877
    2878
    2879
    2880
    2881
    2882
    2883
    2884
    2885
    2886
    2887
    2888
    2889
    2890
    2891
    2892
    2893
    2894
    2895
    2896
    2897
    2898
    2899
    2900
    2901
    2902
    2903
    2904
    2905
    2906
    2907
    2908
    2909
    2910
    2911
    2912
    2913
    2914
    2915
    2916
    2917
    2918
    2919
    2920
    2921
    2922
    2923
    2924
    2925
    2926
    2927
    2928
    2929
    2930
    2931
    2932
    2933
    2934
    2935
    2936
    2937
    2938
    2939
    2940
    2941
    2942
    2943
    2944
    2945
    2946
    2947
    2948
    2949
    2950
    2951
    2952
    2953
    2954
    2955
    2956
    2957
    2958
    2959
    2960
    2961
    2962
    2963
    2964
    2965
    2966
    2967
    2968
    2969
    2970
    2971
    2972
    2973
    2974
    2975
    2976
    2977
    2978
    2979
    2980
    2981
    2982
    2983
    2984
    2985
    2986
    2987
    2988
    2989
    2990
    2991
    2992
    2993
    2994
    2995
    2996
    2997
    2998
    2999
    3000
    3001
    3002
    3003
    3004
    3005
    3006
    3007
    3008

    1×

    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×

    1×

    1×

    117×

    117×

    117×

    117×

    117×

    117×

    117×

    117×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    2×
    2×
    2×
    2×
    2×
    2×

    2×
    2×

    2×
    2×
    2×
    2×

    2×

    2×

    1×

    131×

    22×

    22×

    22×
    22×
    22×
    2×

    22×
    22×
    22×

    22×
    11×

    11×

    11×
    8×

    8×
    2×

    2×

    6×

    3×

    3×

    1×
    17×
    6×
    11×

    9×

    9×

    2×

    1×
    28×

    28×
    28×
    28×
    28×

    1×
    212×
    212×

    212×

    212×
    212×
    13790×
    13790×
    13790×
    13790×
    13790×

    212×
    4×

    208×

    1×
    3×
    3×

    3×

    1×
    62×
    62×

    62×

    1×
    1×
    1×
    1×

    1×
    2×
    2×
    2×

    1×
    6×

    1×
    3×

    3×

    3×

    3×

    3×
    3×

    3×
    3×
    3×

    3×
    3×

    3×
    3×

    3×
    1×
    1×
    1×
    2×

    2×
    1×
    1×
    1×

    3×
    3×

    3×

    3×
    1×

    3×
    3×

    3×

    3×
    1×

    3×
    3×

    3×

    3×

    3×

    3×

    3×

    1×
    2×

    2×

    2×

    2×

    2×
    2×

    2×

    2×

    1×
    8×

    8×

    8×

    8×

    8×
    8×

    8×

    8×

    1×
    18×

    18×

    18×

    18×

    18×
    18×

    18×

    18×
    18×
    18×
    3×

    18×

    18×
    2×

    1×
    141×

    141×

    141×

    1×
    11×

    11×

    11×
    11×

    11×

    11×
    11×
    11×

    11×
    11×
    11×
    11×
    11×
    11×

    1×
    1×

    1×

    1×

    1×

    1×

    1×
    1×
    1×

    1×
    4×

    4×

    4×
    4×

    4×

    4×
    4×
    4×

    4×
    4×

    11×

    4×
    4×
    4×

    1×
    3×

    3×
    3×

    3×
    3×

    1×
    70×

    70×

    1×
    5×

    5×

    5×

    5×

    5×
    5×
    5×
    5×
    5×

    1×
    2×

    2×

    2×

    2×

    2×
    2×
    2×

    2×
    2×

    1×
    77×

    77×

    77×

    77×

    77×
    3×

    74×
    74×
    74×
    74×
    137×
    137×
    51×
    51×

    74×

    23×

    23×
    23×
    1×
    1×

    1×
    1×
    1×
    1×
    1×

    1×

    1×

    1×
    1×
    1×
    1×
    22×
    1×
    1×
    1×
    1×
    21×
    20×
    20×
    20×
    20×
    1×
    1×

    51×

    1×
    63×

    63×
    63×

    63×

    63×
    60×
    60×

    60×
    60×
    60×

    3×

    1×
    141×

    141×

    141×

    141×

    141×
    139×
    139×
    139×
    139×
    139×
    2×
    2×

    139×

    139×
    139×

    2×

    1×
    22×

    22×
    22×

    22×

    22×

    22×
    22×
    3×

    22×

    22×

    22×

    22×

    22×
    2×

    22×

    1×

    22×
    22×
    22×
    22×
    22×
    22×
    108×
    108×
    108×
    108×
    108×

    22×
    3×

    22×
    3×

    1×
    1×

    1×
    1×
    1×
    1×

    1×
    1×

    1×

    1×

    1×
    2×

    2×

    2×

    1×
    7×

    7×
    7×

    7×

    7×

    7×
    4×

    4×
    2×

    4×

    4×
    2×

    1×
    5×

    5×

    5×
    5×
    2×

    3×
    3×

    3×
    2×
    1×
    1×

    1×
    1×

    1×

    1×

    1×
    2×

    2×

    2×
    2×
    2×
    2×

    2×

    1×
    2×

    2×

    2×

    2×
    2×

    2×

    2×

    2×

    1×
    139×

    139×

    139×

    139×
    139×

    139×

    139×

    139×

    1×
    2×

    2×
    2×

    1×
    11×

    11×
    11×

    11×

    11×
    11×
    11×

    11×
    11×
    11×
    11×
    11×
    11×
    11×
    11×
    11×
    11×
    1×
    1×
    1×
    1×

    11×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×
    29×

    29×
    29×

    29×

    29×

    29×
    29×

    1×
    131×

    131×

    131×

    131×

    131×
    131×
    131×
    71×

    131×

    131×
    131×
    73×

    131×
    131×

    131×
    131×
    131×
    131×

    131×

    131×

    131×

    131×

    1×
    7×

    7×
    7×
    7×
    7×
    7×
    7×
    7×

    7×

    7×

    1×
    1×

    1×

    1×
    1×

    1×
    1×

    1×
    1×

    1×

    1×

    1×

    1×

    1×

    1×
    140×

    140×
    1×

    139×
    139×
    139×
    23×

    23×
    23×

    116×
    51×

    51×
    51×

    65×
    61×
    61×
    61×
    67×
    67×
    67×

    61×

    4×

    1×
    5×

    5×

    5×
    5×
    5×

    1×
    5×
    5×
    5×
    5×
    5×
    4×

    1×

    1×
    12×
    12×
    12×

    4×

    8×
    7×
    7×

    7×
    7×
    4×

    4×

    1×
    2×
    2×

    2×

    2×
    2×
    2×

    2×

    1×
    2×
    2×
    2×
    2×

    2×

    1×
    5×
    5×
    5×

    2×

    2×

    5×
    5×
    5×

    3×

    5×

    1×

    1×
    3×
    3×
    3×
    3×
    3×
    12×
    12×

    3×

    1×

    26×
    26×

    26×
    26×

    26×
    26×

    8×
    18×

    18×

    26×
    26×
    26×
    26×
    26×
    26×
    44×

    26×
    45×
    45×
    76×

    26×

    1×
    1×
    1×

    1×
    1×
    1×
    1×
    1×
    1×

    1×

    1×
    1×

    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×
    1×
    1×
    1×
    1×

    1×
    1×
    1×

    1×
    1×

    1×

    1×

    1×
    1×
    1×

    1×
    1×
    1×

    1×
    1×
    1×
    1×

    1×
    1×
    1×
    1×
    1×
    1×

    1×
    1×
    1×

    1×
    1×

    1×
    1×

    1×
    1×
    1×

    1×
    1×
    1×
    1×

    1×

    3×

    3×
    3×

    3×

    3×
    3×
    1×

    1×
    2×
    1×

    1×
    1×
    1×

    1×

    3×

    1×
    9×
    9×

    1×
    34×

    34×
    3×

    34×

    34×
    34×

    5×
    5×
    5×
    5×
    4×

    5×
    5×
    1×

    34×
    34×
    34×
    34×

    34×
    34×
    34×
    21×

    34×

    1×
    26×

    26×
    26×
    26×
    26×
    26×

    1×
    7×

    7×
    7×

    7×
    7×

    7×

    7×

    1×
    1×
    1×

    1×
    2×

    1×
    4×
    4×
    4×
    4×
    4×
    4×
    4×
    1×

    4×
    1×

    4×
    1×

    4×
    1×

    4×
    4×
    4×
    4×

    1×
    1×
    1×
    1×
    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×
    4×

    1×

    2×

    2×
    2×

    2×

    1×

    22×
    21×

    21×
    21×

    21×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×
    33×
    33×
    33×
    33×
    33×

    33×
    33×

    33×
    33×
    33×
    1×
    32×
    32×

    33×
    33×
    33×

    33×

     // FIXME http://earth.google.com/kml/1.0 namespace?
    // FIXME why does node.getAttribute return an unknown type?
    // FIXME text
    // FIXME serialize arbitrary feature properties
    // FIXME don't parse style if extractStyles is false

    goog.provide('ol.format.KML');

    goog.require('goog.Uri');
    goog.require('goog.array');
    goog.require('goog.asserts');
    goog.require('goog.dom.NodeType');
    goog.require('goog.object');
    goog.require('ol');
    goog.require('ol.Feature');
    goog.require('ol.FeatureStyleFunction');
    goog.require('ol.array');
    goog.require('ol.color');
    goog.require('ol.format.Feature');
    goog.require('ol.format.XMLFeature');
    goog.require('ol.format.XSD');
    goog.require('ol.geom.Geometry');
    goog.require('ol.geom.GeometryCollection');
    goog.require('ol.geom.GeometryLayout');
    goog.require('ol.geom.GeometryType');
    goog.require('ol.geom.LineString');
    goog.require('ol.geom.LinearRing');
    goog.require('ol.geom.MultiLineString');
    goog.require('ol.geom.MultiPoint');
    goog.require('ol.geom.MultiPolygon');
    goog.require('ol.geom.Point');
    goog.require('ol.geom.Polygon');
    goog.require('ol.math');
    goog.require('ol.proj');
    goog.require('ol.style.Fill');
    goog.require('ol.style.Icon');
    goog.require('ol.style.IconAnchorUnits');
    goog.require('ol.style.IconOrigin');
    goog.require('ol.style.Image');
    goog.require('ol.style.Stroke');
    goog.require('ol.style.Style');
    goog.require('ol.style.Text');
    goog.require('ol.xml');

    /**
     * @typedef {{x: number, xunits: (ol.style.IconAnchorUnits|undefined),
     *            y: number, yunits: (ol.style.IconAnchorUnits|undefined)}}
     */
    ol.format.KMLVec2_;

    /**
     * @typedef {{flatCoordinates: Array.<number>,
     *            whens: Array.<number>}}
     */
    ol.format.KMLGxTrackObject_;

    /**
     * @classdesc
     * Feature format for reading and writing data in the KML format.
     *
     * @constructor
     * @extends {ol.format.XMLFeature}
     * @param {olx.format.KMLOptions=} opt_options Options.
     * @api stable
     */
    ol.format.KML = function(opt_options) {

      var options = opt_options ? opt_options : {};

      goog.base(this);

      /**
       * @inheritDoc
       */
      this.defaultDataProjection = ol.proj.get('EPSG:4326');

      /**
       * @private
       * @type {Array.<ol.style.Style>}
       */
      this.defaultStyle_ = options.defaultStyle ?
          options.defaultStyle : ol.format.KML.DEFAULT_STYLE_ARRAY_;

      /**
       * @private
       * @type {boolean}
       */
      this.extractStyles_ = options.extractStyles !== undefined ?
          options.extractStyles : true;

      /**
       * @private
       * @type {boolean}
       */
      this.writeStyles_ = options.writeStyles !== undefined ?
          options.writeStyles : true;

      /**
       * @private
       * @type {Object.<string, (Array.<ol.style.Style>|string)>}
       */
      this.sharedStyles_ = {};

      /**
       * @private
       * @type {boolean}
       */
      this.showPointNames_ = options.showPointNames !== undefined ?
          options.showPointNames : true;

    };
    goog.inherits(ol.format.KML, ol.format.XMLFeature);

    /**
     * @const
     * @type {Array.<string>}
     * @private
     */
    ol.format.KML.EXTENSIONS_ = ['.kml'];

    /**
     * @const
     * @type {Array.<string>}
     * @private
     */
    ol.format.KML.GX_NAMESPACE_URIS_ = [
      'http://www.google.com/kml/ext/2.2'
    ];

    /**
     * @const
     * @type {Array.<string>}
     * @private
     */
    ol.format.KML.NAMESPACE_URIS_ = [
      null,
      'http://earth.google.com/kml/2.0',
      'http://earth.google.com/kml/2.1',
      'http://earth.google.com/kml/2.2',
      'http://www.opengis.net/kml/2.2'
    ];

    /**
     * @const
     * @type {string}
     * @private
     */
    ol.format.KML.SCHEMA_LOCATION_ = 'http://www.opengis.net/kml/2.2 ' +
        'https://developers.google.com/kml/schema/kml22gx.xsd';

    /**
     * @const
     * @type {ol.Color}
     * @private
     */
    ol.format.KML.DEFAULT_COLOR_ = [255, 255, 255, 1];

    /**
     * @const
     * @type {ol.style.Fill}
     * @private
     */
    ol.format.KML.DEFAULT_FILL_STYLE_ = new ol.style.Fill({
      color: ol.format.KML.DEFAULT_COLOR_
    });

    /**
     * @const
     * @type {ol.Size}
     * @private
     */
    ol.format.KML.DEFAULT_IMAGE_STYLE_ANCHOR_ = [20, 2]; // FIXME maybe [8, 32] ?

    /**
     * @const
     * @type {ol.style.IconAnchorUnits}
     * @private
     */
    ol.format.KML.DEFAULT_IMAGE_STYLE_ANCHOR_X_UNITS_ =
        ol.style.IconAnchorUnits.PIXELS;

    /**
     * @const
     * @type {ol.style.IconAnchorUnits}
     * @private
     */
    ol.format.KML.DEFAULT_IMAGE_STYLE_ANCHOR_Y_UNITS_ =
        ol.style.IconAnchorUnits.PIXELS;

    /**
     * @const
     * @type {ol.Size}
     * @private
     */
    ol.format.KML.DEFAULT_IMAGE_STYLE_SIZE_ = [64, 64];

    /**
     * @const
     * @type {string}
     * @private
     */
    ol.format.KML.DEFAULT_IMAGE_STYLE_SRC_ =
        'https://maps.google.com/mapfiles/kml/pushpin/ylw-pushpin.png';

    /**
     * @const
     * @type {number}
     * @private
     */
    ol.format.KML.DEFAULT_IMAGE_SCALE_MULTIPLIER_ = 0.5;

    /**
     * @const
     * @type {ol.style.Image}
     * @private
     */
    ol.format.KML.DEFAULT_IMAGE_STYLE_ = new ol.style.Icon({
      anchor: ol.format.KML.DEFAULT_IMAGE_STYLE_ANCHOR_,
      anchorOrigin: ol.style.IconOrigin.BOTTOM_LEFT,
      anchorXUnits: ol.format.KML.DEFAULT_IMAGE_STYLE_ANCHOR_X_UNITS_,
      anchorYUnits: ol.format.KML.DEFAULT_IMAGE_STYLE_ANCHOR_Y_UNITS_,
      crossOrigin: 'anonymous',
      rotation: 0,
      scale: ol.format.KML.DEFAULT_IMAGE_SCALE_MULTIPLIER_,
      size: ol.format.KML.DEFAULT_IMAGE_STYLE_SIZE_,
      src: ol.format.KML.DEFAULT_IMAGE_STYLE_SRC_
    });

    /**
     * @const
     * @type {ol.style.Stroke}
     * @private
     */
    ol.format.KML.DEFAULT_STROKE_STYLE_ = new ol.style.Stroke({
      color: ol.format.KML.DEFAULT_COLOR_,
      width: 1
    });

    /**
     * @const
     * @type {ol.style.Stroke}
     * @private
     */
    ol.format.KML.DEFAULT_TEXT_STROKE_STYLE_ = new ol.style.Stroke({
      color: [51, 51, 51, 1],
      width: 2
    });

    /**
     * @const
     * @type {ol.style.Text}
     * @private
     */
    ol.format.KML.DEFAULT_TEXT_STYLE_ = new ol.style.Text({
      font: 'bold 16px Helvetica',
      fill: ol.format.KML.DEFAULT_FILL_STYLE_,
      stroke: ol.format.KML.DEFAULT_TEXT_STROKE_STYLE_,
      scale: 0.8
    });

    /**
     * @const
     * @type {ol.style.Style}
     * @private
     */
    ol.format.KML.DEFAULT_STYLE_ = new ol.style.Style({
      fill: ol.format.KML.DEFAULT_FILL_STYLE_,
      image: ol.format.KML.DEFAULT_IMAGE_STYLE_,
      text: ol.format.KML.DEFAULT_TEXT_STYLE_,
      stroke: ol.format.KML.DEFAULT_STROKE_STYLE_,
      zIndex: 0
    });

    /**
     * @const
     * @type {Array.<ol.style.Style>}
     * @private
     */
    ol.format.KML.DEFAULT_STYLE_ARRAY_ = [ol.format.KML.DEFAULT_STYLE_];

    /**
     * @const
     * @type {Object.<string, ol.style.IconAnchorUnits>}
     * @private
     */
    ol.format.KML.ICON_ANCHOR_UNITS_MAP_ = {
      'fraction': ol.style.IconAnchorUnits.FRACTION,
      'pixels': ol.style.IconAnchorUnits.PIXELS
    };

    /**
     * @param {ol.style.Style|undefined} foundStyle Style.
     * @param {string} name Name.
     * @return {ol.style.Style} style Style.
     * @private
     */
    ol.format.KML.createNameStyleFunction_ = function(foundStyle, name) {
      /** @type {?ol.style.Text} */
      var textStyle = null;
      var textOffset = [0, 0];
      var textAlign = 'start';
      Eif (foundStyle.getImage()) {
        var imageSize = foundStyle.getImage().getImageSize();
        Iif (imageSize && imageSize.length == 2) {
          // Offset the label to be centered to the right of the icon, if there is
          // one.
          textOffset[0] = foundStyle.getImage().getScale() * imageSize[0] / 2;
          textOffset[1] = -foundStyle.getImage().getScale() * imageSize[1] / 2;
          textAlign = 'left';
        }
      }
      Eif (!goog.object.isEmpty(foundStyle.getText())) {
        textStyle = /** @type {ol.style.Text} */
            (goog.object.clone(foundStyle.getText()));
        textStyle.setText(name);
        textStyle.setTextAlign(textAlign);
        textStyle.setOffsetX(textOffset[0]);
        textStyle.setOffsetY(textOffset[1]);
      } else {
        textStyle = new ol.style.Text({
          text: name,
          offsetX: textOffset[0],
          offsetY: textOffset[1],
          textAlign: textAlign
        });
      }
      var nameStyle = new ol.style.Style({
        text: textStyle
      });
      return nameStyle;
    };

    /**
     * @param {Array.<ol.style.Style>|undefined} style Style.
     * @param {string} styleUrl Style URL.
     * @param {Array.<ol.style.Style>} defaultStyle Default style.
     * @param {Object.<string, (Array.<ol.style.Style>|string)>} sharedStyles Shared
     *          styles.
     * @param {boolean|undefined} showPointNames true to show names for point
     *          placemarks.
     * @return {ol.FeatureStyleFunction} Feature style function.
     * @private
     */
    ol.format.KML.createFeatureStyleFunction_ = function(style, styleUrl,
        defaultStyle, sharedStyles, showPointNames) {

      return (
          /**
           * @param {number} resolution Resolution.
           * @return {Array.<ol.style.Style>} Style.
           * @this {ol.Feature}
           */
          function(resolution) {
            var drawName = showPointNames;
            /** @type {ol.style.Style|undefined} */
            var nameStyle;
            /** @type {string} */
            var name = '';
            Eif (drawName) {
              if (this.getGeometry()) {
                drawName = (this.getGeometry().getType() ===
                            ol.geom.GeometryType.POINT);
              }
            }

            Eif (drawName) {
              name = /** @type {string} */ (this.getProperties()['name']);
              drawName = drawName && name;
            }

            if (style) {
              Iif (drawName) {
                nameStyle = ol.format.KML.createNameStyleFunction_(style[0],
                    name);
                return style.concat(nameStyle);
              }
              return style;
            }
            if (styleUrl) {
              var foundStyle = ol.format.KML.findStyle_(styleUrl, defaultStyle,
                  sharedStyles);
              if (drawName) {
                nameStyle = ol.format.KML.createNameStyleFunction_(foundStyle[0],
                    name);
                return foundStyle.concat(nameStyle);
              }
              return foundStyle;
            }
            Iif (drawName) {
              nameStyle = ol.format.KML.createNameStyleFunction_(defaultStyle[0],
                  name);
              return defaultStyle.concat(nameStyle);
            }
            return defaultStyle;
          });
    };

    /**
     * @param {Array.<ol.style.Style>|string|undefined} styleValue Style value.
     * @param {Array.<ol.style.Style>} defaultStyle Default style.
     * @param {Object.<string, (Array.<ol.style.Style>|string)>} sharedStyles
     * Shared styles.
     * @return {Array.<ol.style.Style>} Style.
     * @private
     */
    ol.format.KML.findStyle_ = function(styleValue, defaultStyle, sharedStyles) {
      if (goog.isArray(styleValue)) {
        return styleValue;
      } else if (goog.isString(styleValue)) {
        // KML files in the wild occasionally forget the leading `#` on styleUrls
        // defined in the same document.  Add a leading `#` if it enables to find
        // a style.
        Iif (!(styleValue in sharedStyles) && ('#' + styleValue in sharedStyles)) {
          styleValue = '#' + styleValue;
        }
        return ol.format.KML.findStyle_(
            sharedStyles[styleValue], defaultStyle, sharedStyles);
      } else {
        return defaultStyle;
      }
    };

    /**
     * @param {Node} node Node.
     * @private
     * @return {ol.Color|undefined} Color.
     */
    ol.format.KML.readColor_ = function(node) {
      var s = ol.xml.getAllTextContent(node, false);
      // The KML specification states that colors should not include a leading `#`
      // but we tolerate them.
      var m = /^\s*#?\s*([0-9A-Fa-f]{8})\s*$/.exec(s);
      Eif (m) {
        var hexColor = m[1];
        return [
          parseInt(hexColor.substr(6, 2), 16),
          parseInt(hexColor.substr(4, 2), 16),
          parseInt(hexColor.substr(2, 2), 16),
          parseInt(hexColor.substr(0, 2), 16) / 255
        ];

      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @private
     * @return {Array.<number>|undefined} Flat coordinates.
     */
    ol.format.KML.readFlatCoordinates_ = function(node) {
      var s = ol.xml.getAllTextContent(node, false);
      var flatCoordinates = [];
      // The KML specification states that coordinate tuples should not include
      // spaces, but we tolerate them.
      var re =
          /^\s*([+\-]?\d*\.?\d+(?:e[+\-]?\d+)?)\s*,\s*([+\-]?\d*\.?\d+(?:e[+\-]?\d+)?)(?:\s*,\s*([+\-]?\d*\.?\d+(?:e[+\-]?\d+)?))?\s*/i;
      var m;
      while ((m = re.exec(s))) {
        var x = parseFloat(m[1]);
        var y = parseFloat(m[2]);
        var z = m[3] ? parseFloat(m[3]) : 0;
        flatCoordinates.push(x, y, z);
        s = s.substr(m[0].length);
      }
      if (s !== '') {
        return undefined;
      }
      return flatCoordinates;
    };

    /**
     * @param {Node} node Node.
     * @private
     * @return {string|undefined} Style URL.
     */
    ol.format.KML.readStyleUrl_ = function(node) {
      var s = ol.xml.getAllTextContent(node, false).trim();
      Iif (node.baseURI) {
        return goog.Uri.resolve(node.baseURI, s).toString();
      } else {
        return s;
      }

    };

    /**
     * @param {Node} node Node.
     * @private
     * @return {string} URI.
     */
    ol.format.KML.readURI_ = function(node) {
      var s = ol.xml.getAllTextContent(node, false);
      Iif (node.baseURI) {
        return goog.Uri.resolve(node.baseURI, s.trim()).toString();
      } else {
        return s.trim();
      }
    };

    /**
     * @param {Node} node Node.
     * @private
     * @return {ol.format.KMLVec2_} Vec2.
     */
    ol.format.KML.readVec2_ = function(node) {
      var xunits = node.getAttribute('xunits');
      var yunits = node.getAttribute('yunits');
      return {
        x: parseFloat(node.getAttribute('x')),
        xunits: ol.format.KML.ICON_ANCHOR_UNITS_MAP_[xunits],
        y: parseFloat(node.getAttribute('y')),
        yunits: ol.format.KML.ICON_ANCHOR_UNITS_MAP_[yunits]
      };
    };

    /**
     * @param {Node} node Node.
     * @private
     * @return {number|undefined} Scale.
     */
    ol.format.KML.readScale_ = function(node) {
      var number = ol.format.XSD.readDecimal(node);
      Eif (number !== undefined) {
        return Math.sqrt(number);
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {Array.<ol.style.Style>|string|undefined} StyleMap.
     */
    ol.format.KML.readStyleMapValue_ = function(node, objectStack) {
      return ol.xml.pushParseAndPop(
          /** @type {Array.<ol.style.Style>|string|undefined} */ (undefined),
          ol.format.KML.STYLE_MAP_PARSERS_, node, objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.IconStyleParser_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be an ELEMENT');
      goog.asserts.assert(node.localName == 'IconStyle',
          'localName should be IconStyle');
      // FIXME refreshMode
      // FIXME refreshInterval
      // FIXME viewRefreshTime
      // FIXME viewBoundScale
      // FIXME viewFormat
      // FIXME httpQuery
      var object = ol.xml.pushParseAndPop(
          {}, ol.format.KML.ICON_STYLE_PARSERS_, node, objectStack);
      Iif (!object) {
        return;
      }
      var styleObject = /** @type {Object} */ (objectStack[objectStack.length - 1]);
      goog.asserts.assert(goog.isObject(styleObject),
          'styleObject should be an Object');
      var IconObject = 'Icon' in object ? object['Icon'] : {};
      var src;
      var href = /** @type {string|undefined} */
          (IconObject['href']);
      Eif (href) {
        src = href;
      } else {
        src = ol.format.KML.DEFAULT_IMAGE_STYLE_SRC_;
      }
      var anchor, anchorXUnits, anchorYUnits;
      var hotSpot = /** @type {ol.format.KMLVec2_|undefined} */
          (object['hotSpot']);
      if (hotSpot) {
        anchor = [hotSpot.x, hotSpot.y];
        anchorXUnits = hotSpot.xunits;
        anchorYUnits = hotSpot.yunits;
      } else Iif (src === ol.format.KML.DEFAULT_IMAGE_STYLE_SRC_) {
        anchor = ol.format.KML.DEFAULT_IMAGE_STYLE_ANCHOR_;
        anchorXUnits = ol.format.KML.DEFAULT_IMAGE_STYLE_ANCHOR_X_UNITS_;
        anchorYUnits = ol.format.KML.DEFAULT_IMAGE_STYLE_ANCHOR_Y_UNITS_;
      } else if (/^http:\/\/maps\.(?:google|gstatic)\.com\//.test(src)) {
        anchor = [0.5, 0];
        anchorXUnits = ol.style.IconAnchorUnits.FRACTION;
        anchorYUnits = ol.style.IconAnchorUnits.FRACTION;
      }

      var offset;
      var x = /** @type {number|undefined} */
          (IconObject['x']);
      var y = /** @type {number|undefined} */
          (IconObject['y']);
      if (x !== undefined && y !== undefined) {
        offset = [x, y];
      }

      var size;
      var w = /** @type {number|undefined} */
          (IconObject['w']);
      var h = /** @type {number|undefined} */
          (IconObject['h']);
      if (w !== undefined && h !== undefined) {
        size = [w, h];
      }

      var rotation;
      var heading = /** @type {number} */
          (object['heading']);
      Iif (heading !== undefined) {
        rotation = ol.math.toRadians(heading);
      }

      var scale = /** @type {number|undefined} */
          (object['scale']);
      Iif (src == ol.format.KML.DEFAULT_IMAGE_STYLE_SRC_) {
        size = ol.format.KML.DEFAULT_IMAGE_STYLE_SIZE_;
      }

      var imageStyle = new ol.style.Icon({
        anchor: anchor,
        anchorOrigin: ol.style.IconOrigin.BOTTOM_LEFT,
        anchorXUnits: anchorXUnits,
        anchorYUnits: anchorYUnits,
        crossOrigin: 'anonymous', // FIXME should this be configurable?
        offset: offset,
        offsetOrigin: ol.style.IconOrigin.BOTTOM_LEFT,
        rotation: rotation,
        scale: ol.format.KML.DEFAULT_IMAGE_SCALE_MULTIPLIER_ * scale,
        size: size,
        src: src
      });
      styleObject['imageStyle'] = imageStyle;
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.LabelStyleParser_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'LabelStyle',
          'localName should be LabelStyle');
      // FIXME colorMode
      var object = ol.xml.pushParseAndPop(
          {}, ol.format.KML.LABEL_STYLE_PARSERS_, node, objectStack);
      Iif (!object) {
        return;
      }
      var styleObject = objectStack[objectStack.length - 1];
      goog.asserts.assert(goog.isObject(styleObject),
          'styleObject should be an Object');
      var textStyle = new ol.style.Text({
        fill: new ol.style.Fill({
          color: /** @type {ol.Color} */
              ('color' in object ? object['color'] : ol.format.KML.DEFAULT_COLOR_)
        }),
        scale: /** @type {number|undefined} */
            (object['scale'])
      });
      styleObject['textStyle'] = textStyle;
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.LineStyleParser_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'LineStyle',
          'localName should be LineStyle');
      // FIXME colorMode
      // FIXME gx:outerColor
      // FIXME gx:outerWidth
      // FIXME gx:physicalWidth
      // FIXME gx:labelVisibility
      var object = ol.xml.pushParseAndPop(
          {}, ol.format.KML.LINE_STYLE_PARSERS_, node, objectStack);
      Iif (!object) {
        return;
      }
      var styleObject = objectStack[objectStack.length - 1];
      goog.asserts.assert(goog.isObject(styleObject),
          'styleObject should be an Object');
      var strokeStyle = new ol.style.Stroke({
        color: /** @type {ol.Color} */
            ('color' in object ? object['color'] : ol.format.KML.DEFAULT_COLOR_),
        width: /** @type {number} */ ('width' in object ? object['width'] : 1)
      });
      styleObject['strokeStyle'] = strokeStyle;
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.PolyStyleParser_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'PolyStyle',
          'localName should be PolyStyle');
      // FIXME colorMode
      var object = ol.xml.pushParseAndPop(
          {}, ol.format.KML.POLY_STYLE_PARSERS_, node, objectStack);
      Iif (!object) {
        return;
      }
      var styleObject = objectStack[objectStack.length - 1];
      goog.asserts.assert(goog.isObject(styleObject),
          'styleObject should be an Object');
      var fillStyle = new ol.style.Fill({
        color: /** @type {ol.Color} */
            ('color' in object ? object['color'] : ol.format.KML.DEFAULT_COLOR_)
      });
      styleObject['fillStyle'] = fillStyle;
      var fill = /** @type {boolean|undefined} */ (object['fill']);
      if (fill !== undefined) {
        styleObject['fill'] = fill;
      }
      var outline =
          /** @type {boolean|undefined} */ (object['outline']);
      if (outline !== undefined) {
        styleObject['outline'] = outline;
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {Array.<number>} LinearRing flat coordinates.
     */
    ol.format.KML.readFlatLinearRing_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'LinearRing',
          'localName should be LinearRing');
      return /** @type {Array.<number>} */ (ol.xml.pushParseAndPop(
          null, ol.format.KML.FLAT_LINEAR_RING_PARSERS_, node, objectStack));
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.gxCoordParser_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(ol.array.includes(
          ol.format.KML.GX_NAMESPACE_URIS_, node.namespaceURI),
          'namespaceURI of the node should be known to the KML parser');
      goog.asserts.assert(node.localName == 'coord', 'localName should be coord');
      var gxTrackObject = /** @type {ol.format.KMLGxTrackObject_} */
          (objectStack[objectStack.length - 1]);
      goog.asserts.assert(goog.isObject(gxTrackObject),
          'gxTrackObject should be an Object');
      var flatCoordinates = gxTrackObject.flatCoordinates;
      var s = ol.xml.getAllTextContent(node, false);
      var re =
          /^\s*([+\-]?\d+(?:\.\d*)?(?:e[+\-]?\d*)?)\s+([+\-]?\d+(?:\.\d*)?(?:e[+\-]?\d*)?)\s+([+\-]?\d+(?:\.\d*)?(?:e[+\-]?\d*)?)\s*$/i;
      var m = re.exec(s);
      Eif (m) {
        var x = parseFloat(m[1]);
        var y = parseFloat(m[2]);
        var z = parseFloat(m[3]);
        flatCoordinates.push(x, y, z, 0);
      } else {
        flatCoordinates.push(0, 0, 0, 0);
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {ol.geom.MultiLineString|undefined} MultiLineString.
     */
    ol.format.KML.readGxMultiTrack_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(ol.array.includes(
          ol.format.KML.GX_NAMESPACE_URIS_, node.namespaceURI),
          'namespaceURI of the node should be known to the KML parser');
      goog.asserts.assert(node.localName == 'MultiTrack',
          'localName should be MultiTrack');
      var lineStrings = ol.xml.pushParseAndPop(
          /** @type {Array.<ol.geom.LineString>} */ ([]),
          ol.format.KML.GX_MULTITRACK_GEOMETRY_PARSERS_, node, objectStack);
      Iif (!lineStrings) {
        return undefined;
      }
      var multiLineString = new ol.geom.MultiLineString(null);
      multiLineString.setLineStrings(lineStrings);
      return multiLineString;
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {ol.geom.LineString|undefined} LineString.
     */
    ol.format.KML.readGxTrack_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(ol.array.includes(
          ol.format.KML.GX_NAMESPACE_URIS_, node.namespaceURI),
          'namespaceURI of the node should be known to the KML parser');
      goog.asserts.assert(node.localName == 'Track', 'localName should be Track');
      var gxTrackObject = ol.xml.pushParseAndPop(
          /** @type {ol.format.KMLGxTrackObject_} */ ({
            flatCoordinates: [],
            whens: []
          }), ol.format.KML.GX_TRACK_PARSERS_, node, objectStack);
      Iif (!gxTrackObject) {
        return undefined;
      }
      var flatCoordinates = gxTrackObject.flatCoordinates;
      var whens = gxTrackObject.whens;
      goog.asserts.assert(flatCoordinates.length / 4 == whens.length,
          'the length of the flatCoordinates array divided by 4 should be the ' +
          'length of the whens array');
      var i, ii;
      for (i = 0, ii = Math.min(flatCoordinates.length, whens.length); i < ii;
           ++i) {
        flatCoordinates[4 * i + 3] = whens[i];
      }
      var lineString = new ol.geom.LineString(null);
      lineString.setFlatCoordinates(ol.geom.GeometryLayout.XYZM, flatCoordinates);
      return lineString;
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {Object} Icon object.
     */
    ol.format.KML.readIcon_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'Icon', 'localName should be Icon');
      var iconObject = ol.xml.pushParseAndPop(
          {}, ol.format.KML.ICON_PARSERS_, node, objectStack);
      Eif (iconObject) {
        return iconObject;
      } else {
        return null;
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {Array.<number>} Flat coordinates.
     */
    ol.format.KML.readFlatCoordinatesFromNode_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      return /** @type {Array.<number>} */ (ol.xml.pushParseAndPop(null,
          ol.format.KML.GEOMETRY_FLAT_COORDINATES_PARSERS_, node, objectStack));
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {ol.geom.LineString|undefined} LineString.
     */
    ol.format.KML.readLineString_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'LineString',
          'localName should be LineString');
      var properties = ol.xml.pushParseAndPop(/** @type {Object<string,*>} */ ({}),
          ol.format.KML.EXTRUDE_AND_ALTITUDE_MODE_PARSERS_, node,
          objectStack);
      var flatCoordinates =
          ol.format.KML.readFlatCoordinatesFromNode_(node, objectStack);
      Eif (flatCoordinates) {
        var lineString = new ol.geom.LineString(null);
        lineString.setFlatCoordinates(ol.geom.GeometryLayout.XYZ, flatCoordinates);
        lineString.setProperties(properties);
        return lineString;
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {ol.geom.Polygon|undefined} Polygon.
     */
    ol.format.KML.readLinearRing_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'LinearRing',
          'localName should be LinearRing');
      var properties = ol.xml.pushParseAndPop(/** @type {Object<string,*>} */ ({}),
          ol.format.KML.EXTRUDE_AND_ALTITUDE_MODE_PARSERS_, node,
          objectStack);
      var flatCoordinates =
          ol.format.KML.readFlatCoordinatesFromNode_(node, objectStack);
      Eif (flatCoordinates) {
        var polygon = new ol.geom.Polygon(null);
        polygon.setFlatCoordinates(ol.geom.GeometryLayout.XYZ, flatCoordinates,
            [flatCoordinates.length]);
        polygon.setProperties(properties);
        return polygon;
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {ol.geom.Geometry} Geometry.
     */
    ol.format.KML.readMultiGeometry_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'MultiGeometry',
          'localName should be MultiGeometry');
      var geometries = ol.xml.pushParseAndPop(
          /** @type {Array.<ol.geom.Geometry>} */ ([]),
          ol.format.KML.MULTI_GEOMETRY_PARSERS_, node, objectStack);
      Iif (!geometries) {
        return null;
      }
      if (geometries.length === 0) {
        return new ol.geom.GeometryCollection(geometries);
      }
      var homogeneous = true;
      var type = geometries[0].getType();
      var geometry, i, ii;
      for (i = 1, ii = geometries.length; i < ii; ++i) {
        geometry = geometries[i];
        if (geometry.getType() != type) {
          homogeneous = false;
          break;
        }
      }
      if (homogeneous) {
        /** @type {ol.geom.GeometryLayout} */
        var layout;
        /** @type {Array.<number>} */
        var flatCoordinates;
        if (type == ol.geom.GeometryType.POINT) {
          var point = geometries[0];
          goog.asserts.assertInstanceof(point, ol.geom.Point,
              'point should be an ol.geom.Point');
          layout = point.getLayout();
          flatCoordinates = point.getFlatCoordinates();
          for (i = 1, ii = geometries.length; i < ii; ++i) {
            geometry = geometries[i];
            goog.asserts.assertInstanceof(geometry, ol.geom.Point,
                'geometry should be an ol.geom.Point');
            goog.asserts.assert(geometry.getLayout() == layout,
                'geometry layout should be consistent');
            goog.array.extend(flatCoordinates, geometry.getFlatCoordinates());
          }
          var multiPoint = new ol.geom.MultiPoint(null);
          multiPoint.setFlatCoordinates(layout, flatCoordinates);
          ol.format.KML.setCommonGeometryProperties_(multiPoint, geometries);
          return multiPoint;
        } else if (type == ol.geom.GeometryType.LINE_STRING) {
          var multiLineString = new ol.geom.MultiLineString(null);
          multiLineString.setLineStrings(geometries);
          ol.format.KML.setCommonGeometryProperties_(multiLineString, geometries);
          return multiLineString;
        } else if (type == ol.geom.GeometryType.POLYGON) {
          var multiPolygon = new ol.geom.MultiPolygon(null);
          multiPolygon.setPolygons(geometries);
          ol.format.KML.setCommonGeometryProperties_(multiPolygon, geometries);
          return multiPolygon;
        } else Eif (type == ol.geom.GeometryType.GEOMETRY_COLLECTION) {
          return new ol.geom.GeometryCollection(geometries);
        } else {
          goog.asserts.fail('Unexpected type: ' + type);
          return null;
        }
      } else {
        return new ol.geom.GeometryCollection(geometries);
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {ol.geom.Point|undefined} Point.
     */
    ol.format.KML.readPoint_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'Point', 'localName should be Point');
      var properties = ol.xml.pushParseAndPop(/** @type {Object<string,*>} */ ({}),
          ol.format.KML.EXTRUDE_AND_ALTITUDE_MODE_PARSERS_, node,
          objectStack);
      var flatCoordinates =
          ol.format.KML.readFlatCoordinatesFromNode_(node, objectStack);
      if (flatCoordinates) {
        var point = new ol.geom.Point(null);
        goog.asserts.assert(flatCoordinates.length == 3,
            'flatCoordinates should have a length of 3');
        point.setFlatCoordinates(ol.geom.GeometryLayout.XYZ, flatCoordinates);
        point.setProperties(properties);
        return point;
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {ol.geom.Polygon|undefined} Polygon.
     */
    ol.format.KML.readPolygon_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'Polygon',
          'localName should be Polygon');
      var properties = ol.xml.pushParseAndPop(/** @type {Object<string,*>} */ ({}),
          ol.format.KML.EXTRUDE_AND_ALTITUDE_MODE_PARSERS_, node,
          objectStack);
      var flatLinearRings = ol.xml.pushParseAndPop(
          /** @type {Array.<Array.<number>>} */ ([null]),
          ol.format.KML.FLAT_LINEAR_RINGS_PARSERS_, node, objectStack);
      if (flatLinearRings && flatLinearRings[0]) {
        var polygon = new ol.geom.Polygon(null);
        var flatCoordinates = flatLinearRings[0];
        var ends = [flatCoordinates.length];
        var i, ii;
        for (i = 1, ii = flatLinearRings.length; i < ii; ++i) {
          goog.array.extend(flatCoordinates, flatLinearRings[i]);
          ends.push(flatCoordinates.length);
        }
        polygon.setFlatCoordinates(
            ol.geom.GeometryLayout.XYZ, flatCoordinates, ends);
        polygon.setProperties(properties);
        return polygon;
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {Array.<ol.style.Style>} Style.
     */
    ol.format.KML.readStyle_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'Style', 'localName should be Style');
      var styleObject = ol.xml.pushParseAndPop(
          {}, ol.format.KML.STYLE_PARSERS_, node, objectStack);
      Iif (!styleObject) {
        return null;
      }
      var fillStyle = /** @type {ol.style.Fill} */
          ('fillStyle' in styleObject ?
              styleObject['fillStyle'] : ol.format.KML.DEFAULT_FILL_STYLE_);
      var fill = /** @type {boolean|undefined} */ (styleObject['fill']);
      if (fill !== undefined && !fill) {
        fillStyle = null;
      }
      var imageStyle = /** @type {ol.style.Image} */
          ('imageStyle' in styleObject ?
              styleObject['imageStyle'] : ol.format.KML.DEFAULT_IMAGE_STYLE_);
      var textStyle = /** @type {ol.style.Text} */
          ('textStyle' in styleObject ?
              styleObject['textStyle'] : ol.format.KML.DEFAULT_TEXT_STYLE_);
      var strokeStyle = /** @type {ol.style.Stroke} */
          ('strokeStyle' in styleObject ?
              styleObject['strokeStyle'] : ol.format.KML.DEFAULT_STROKE_STYLE_);
      var outline = /** @type {boolean|undefined} */
          (styleObject['outline']);
      if (outline !== undefined && !outline) {
        strokeStyle = null;
      }
      return [new ol.style.Style({
        fill: fillStyle,
        image: imageStyle,
        stroke: strokeStyle,
        text: textStyle,
        zIndex: undefined // FIXME
      })];
    };

    /**
     * Reads an array of geometries and creates arrays for common geometry
     * properties. Then sets them to the multi geometry.
     * @param {ol.geom.MultiPoint|ol.geom.MultiLineString|ol.geom.MultiPolygon}
     * multiGeometry
     * @param {Array.<ol.geom.Geometry>} geometries
     * @private
     */
    ol.format.KML.setCommonGeometryProperties_ = function(multiGeometry,
        geometries) {
      var ii = geometries.length;
      var extrudes = new Array(geometries.length);
      var altitudeModes = new Array(geometries.length);
      var geometry, i, hasExtrude, hasAltitudeMode;
      hasExtrude = hasAltitudeMode = false;
      for (i = 0; i < ii; ++i) {
        geometry = geometries[i];
        extrudes[i] = geometry.get('extrude');
        altitudeModes[i] = geometry.get('altitudeMode');
        hasExtrude = hasExtrude || extrudes[i] !== undefined;
        hasAltitudeMode = hasAltitudeMode || altitudeModes[i];
      }
      if (hasExtrude) {
        multiGeometry.set('extrude', extrudes);
      }
      if (hasAltitudeMode) {
        multiGeometry.set('altitudeMode', altitudeModes);
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.DataParser_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'Data', 'localName should be Data');
      var name = node.getAttribute('name');
      Eif (name !== null) {
        var data = ol.xml.pushParseAndPop(
            undefined, ol.format.KML.DATA_PARSERS_, node, objectStack);
        Eif (data) {
          var featureObject =
              /** @type {Object} */ (objectStack[objectStack.length - 1]);
          goog.asserts.assert(goog.isObject(featureObject),
              'featureObject should be an Object');
          featureObject[name] = data;
        }
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.ExtendedDataParser_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'ExtendedData',
          'localName should be ExtendedData');
      ol.xml.parseNode(ol.format.KML.EXTENDED_DATA_PARSERS_, node, objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.PairDataParser_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'Pair', 'localName should be Pair');
      var pairObject = ol.xml.pushParseAndPop(
          {}, ol.format.KML.PAIR_PARSERS_, node, objectStack);
      Iif (!pairObject) {
        return;
      }
      var key = /** @type {string|undefined} */
          (pairObject['key']);
      if (key && key == 'normal') {
        var styleUrl = /** @type {string|undefined} */
            (pairObject['styleUrl']);
        if (styleUrl) {
          objectStack[objectStack.length - 1] = styleUrl;
        }
        var Style = /** @type {ol.style.Style} */
            (pairObject['Style']);
        if (Style) {
          objectStack[objectStack.length - 1] = Style;
        }
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.PlacemarkStyleMapParser_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'StyleMap',
          'localName should be StyleMap');
      var styleMapValue = ol.format.KML.readStyleMapValue_(node, objectStack);
      if (!styleMapValue) {
        return;
      }
      var placemarkObject = objectStack[objectStack.length - 1];
      goog.asserts.assert(goog.isObject(placemarkObject),
          'placemarkObject should be an Object');
      if (goog.isArray(styleMapValue)) {
        placemarkObject['Style'] = styleMapValue;
      } else Eif (goog.isString(styleMapValue)) {
        placemarkObject['styleUrl'] = styleMapValue;
      } else {
        goog.asserts.fail('styleMapValue has an unknown type');
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.SchemaDataParser_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'SchemaData',
          'localName should be SchemaData');
      ol.xml.parseNode(ol.format.KML.SCHEMA_DATA_PARSERS_, node, objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.SimpleDataParser_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'SimpleData',
          'localName should be SimpleData');
      var name = node.getAttribute('name');
      Eif (name !== null) {
        var data = ol.format.XSD.readString(node);
        var featureObject =
            /** @type {Object} */ (objectStack[objectStack.length - 1]);
        featureObject[name] = data;
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.innerBoundaryIsParser_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'innerBoundaryIs',
          'localName should be innerBoundaryIs');
      var flatLinearRing = ol.xml.pushParseAndPop(
          /** @type {Array.<number>|undefined} */ (undefined),
          ol.format.KML.INNER_BOUNDARY_IS_PARSERS_, node, objectStack);
      Eif (flatLinearRing) {
        var flatLinearRings = /** @type {Array.<Array.<number>>} */
            (objectStack[objectStack.length - 1]);
        goog.asserts.assert(goog.isArray(flatLinearRings),
            'flatLinearRings should be an array');
        goog.asserts.assert(flatLinearRings.length > 0,
            'flatLinearRings array should not be empty');
        flatLinearRings.push(flatLinearRing);
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.outerBoundaryIsParser_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'outerBoundaryIs',
          'localName should be outerBoundaryIs');
      var flatLinearRing = ol.xml.pushParseAndPop(
          /** @type {Array.<number>|undefined} */ (undefined),
          ol.format.KML.OUTER_BOUNDARY_IS_PARSERS_, node, objectStack);
      Eif (flatLinearRing) {
        var flatLinearRings = /** @type {Array.<Array.<number>>} */
            (objectStack[objectStack.length - 1]);
        goog.asserts.assert(goog.isArray(flatLinearRings),
            'flatLinearRings should be an array');
        goog.asserts.assert(flatLinearRings.length > 0,
            'flatLinearRings array should not be empty');
        flatLinearRings[0] = flatLinearRing;
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.LinkParser_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'Link', 'localName should be Link');
      ol.xml.parseNode(ol.format.KML.LINK_PARSERS_, node, objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.whenParser_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'when', 'localName should be when');
      var gxTrackObject = /** @type {ol.format.KMLGxTrackObject_} */
          (objectStack[objectStack.length - 1]);
      goog.asserts.assert(goog.isObject(gxTrackObject),
          'gxTrackObject should be an Object');
      var whens = gxTrackObject.whens;
      var s = ol.xml.getAllTextContent(node, false);
      var re =
          /^\s*(\d{4})($|-(\d{2})($|-(\d{2})($|T(\d{2}):(\d{2}):(\d{2})(Z|(?:([+\-])(\d{2})(?::(\d{2}))?)))))\s*$/;
      var m = re.exec(s);
      Eif (m) {
        var year = parseInt(m[1], 10);
        var month = m[3] ? parseInt(m[3], 10) - 1 : 0;
        var day = m[5] ? parseInt(m[5], 10) : 1;
        var hour = m[7] ? parseInt(m[7], 10) : 0;
        var minute = m[8] ? parseInt(m[8], 10) : 0;
        var second = m[9] ? parseInt(m[9], 10) : 0;
        var when = Date.UTC(year, month, day, hour, minute, second);
        if (m[10] && m[10] != 'Z') {
          var sign = m[11] == '-' ? -1 : 1;
          when += sign * 60 * parseInt(m[12], 10);
          Eif (m[13]) {
            when += sign * 60 * 60 * parseInt(m[13], 10);
          }
        }
        whens.push(when);
      } else {
        whens.push(0);
      }
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.DATA_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'value': ol.xml.makeReplacer(ol.format.XSD.readString)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.EXTENDED_DATA_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'Data': ol.format.KML.DataParser_,
          'SchemaData': ol.format.KML.SchemaDataParser_
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.EXTRUDE_AND_ALTITUDE_MODE_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'extrude': ol.xml.makeObjectPropertySetter(ol.format.XSD.readBoolean),
          'altitudeMode': ol.xml.makeObjectPropertySetter(ol.format.XSD.readString)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.FLAT_LINEAR_RING_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'coordinates': ol.xml.makeReplacer(ol.format.KML.readFlatCoordinates_)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.FLAT_LINEAR_RINGS_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'innerBoundaryIs': ol.format.KML.innerBoundaryIsParser_,
          'outerBoundaryIs': ol.format.KML.outerBoundaryIsParser_
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.GX_TRACK_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'when': ol.format.KML.whenParser_
        }, ol.xml.makeStructureNS(
            ol.format.KML.GX_NAMESPACE_URIS_, {
              'coord': ol.format.KML.gxCoordParser_
            }));

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.GEOMETRY_FLAT_COORDINATES_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'coordinates': ol.xml.makeReplacer(ol.format.KML.readFlatCoordinates_)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.ICON_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'href': ol.xml.makeObjectPropertySetter(ol.format.KML.readURI_)
        }, ol.xml.makeStructureNS(
            ol.format.KML.GX_NAMESPACE_URIS_, {
              'x': ol.xml.makeObjectPropertySetter(ol.format.XSD.readDecimal),
              'y': ol.xml.makeObjectPropertySetter(ol.format.XSD.readDecimal),
              'w': ol.xml.makeObjectPropertySetter(ol.format.XSD.readDecimal),
              'h': ol.xml.makeObjectPropertySetter(ol.format.XSD.readDecimal)
            }));

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.ICON_STYLE_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'Icon': ol.xml.makeObjectPropertySetter(ol.format.KML.readIcon_),
          'heading': ol.xml.makeObjectPropertySetter(ol.format.XSD.readDecimal),
          'hotSpot': ol.xml.makeObjectPropertySetter(ol.format.KML.readVec2_),
          'scale': ol.xml.makeObjectPropertySetter(ol.format.KML.readScale_)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.INNER_BOUNDARY_IS_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'LinearRing': ol.xml.makeReplacer(ol.format.KML.readFlatLinearRing_)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.LABEL_STYLE_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'color': ol.xml.makeObjectPropertySetter(ol.format.KML.readColor_),
          'scale': ol.xml.makeObjectPropertySetter(ol.format.KML.readScale_)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.LINE_STYLE_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'color': ol.xml.makeObjectPropertySetter(ol.format.KML.readColor_),
          'width': ol.xml.makeObjectPropertySetter(ol.format.XSD.readDecimal)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.MULTI_GEOMETRY_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'LineString': ol.xml.makeArrayPusher(ol.format.KML.readLineString_),
          'LinearRing': ol.xml.makeArrayPusher(ol.format.KML.readLinearRing_),
          'MultiGeometry': ol.xml.makeArrayPusher(ol.format.KML.readMultiGeometry_),
          'Point': ol.xml.makeArrayPusher(ol.format.KML.readPoint_),
          'Polygon': ol.xml.makeArrayPusher(ol.format.KML.readPolygon_)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.GX_MULTITRACK_GEOMETRY_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.GX_NAMESPACE_URIS_, {
          'Track': ol.xml.makeArrayPusher(ol.format.KML.readGxTrack_)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.NETWORK_LINK_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'ExtendedData': ol.format.KML.ExtendedDataParser_,
          'Link': ol.format.KML.LinkParser_,
          'address': ol.xml.makeObjectPropertySetter(ol.format.XSD.readString),
          'description': ol.xml.makeObjectPropertySetter(ol.format.XSD.readString),
          'name': ol.xml.makeObjectPropertySetter(ol.format.XSD.readString),
          'open': ol.xml.makeObjectPropertySetter(ol.format.XSD.readBoolean),
          'phoneNumber': ol.xml.makeObjectPropertySetter(ol.format.XSD.readString),
          'visibility': ol.xml.makeObjectPropertySetter(ol.format.XSD.readBoolean)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.LINK_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'href': ol.xml.makeObjectPropertySetter(ol.format.KML.readURI_)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.OUTER_BOUNDARY_IS_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'LinearRing': ol.xml.makeReplacer(ol.format.KML.readFlatLinearRing_)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.PAIR_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'Style': ol.xml.makeObjectPropertySetter(ol.format.KML.readStyle_),
          'key': ol.xml.makeObjectPropertySetter(ol.format.XSD.readString),
          'styleUrl': ol.xml.makeObjectPropertySetter(ol.format.KML.readStyleUrl_)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.PLACEMARK_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'ExtendedData': ol.format.KML.ExtendedDataParser_,
          'MultiGeometry': ol.xml.makeObjectPropertySetter(
              ol.format.KML.readMultiGeometry_, 'geometry'),
          'LineString': ol.xml.makeObjectPropertySetter(
              ol.format.KML.readLineString_, 'geometry'),
          'LinearRing': ol.xml.makeObjectPropertySetter(
              ol.format.KML.readLinearRing_, 'geometry'),
          'Point': ol.xml.makeObjectPropertySetter(
              ol.format.KML.readPoint_, 'geometry'),
          'Polygon': ol.xml.makeObjectPropertySetter(
              ol.format.KML.readPolygon_, 'geometry'),
          'Style': ol.xml.makeObjectPropertySetter(ol.format.KML.readStyle_),
          'StyleMap': ol.format.KML.PlacemarkStyleMapParser_,
          'address': ol.xml.makeObjectPropertySetter(ol.format.XSD.readString),
          'description': ol.xml.makeObjectPropertySetter(ol.format.XSD.readString),
          'name': ol.xml.makeObjectPropertySetter(ol.format.XSD.readString),
          'open': ol.xml.makeObjectPropertySetter(ol.format.XSD.readBoolean),
          'phoneNumber': ol.xml.makeObjectPropertySetter(ol.format.XSD.readString),
          'styleUrl': ol.xml.makeObjectPropertySetter(ol.format.KML.readURI_),
          'visibility': ol.xml.makeObjectPropertySetter(ol.format.XSD.readBoolean)
        }, ol.xml.makeStructureNS(
            ol.format.KML.GX_NAMESPACE_URIS_, {
              'MultiTrack': ol.xml.makeObjectPropertySetter(
                  ol.format.KML.readGxMultiTrack_, 'geometry'),
              'Track': ol.xml.makeObjectPropertySetter(
                  ol.format.KML.readGxTrack_, 'geometry')
            }
        ));

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.POLY_STYLE_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'color': ol.xml.makeObjectPropertySetter(ol.format.KML.readColor_),
          'fill': ol.xml.makeObjectPropertySetter(ol.format.XSD.readBoolean),
          'outline': ol.xml.makeObjectPropertySetter(ol.format.XSD.readBoolean)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.SCHEMA_DATA_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'SimpleData': ol.format.KML.SimpleDataParser_
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.STYLE_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'IconStyle': ol.format.KML.IconStyleParser_,
          'LabelStyle': ol.format.KML.LabelStyleParser_,
          'LineStyle': ol.format.KML.LineStyleParser_,
          'PolyStyle': ol.format.KML.PolyStyleParser_
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Parser>>}
     * @private
     */
    ol.format.KML.STYLE_MAP_PARSERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'Pair': ol.format.KML.PairDataParser_
        });

    /**
     * @inheritDoc
     */
    ol.format.KML.prototype.getExtensions = function() {
      return ol.format.KML.EXTENSIONS_;
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {Array.<ol.Feature>|undefined} Features.
     */
    ol.format.KML.prototype.readDocumentOrFolder_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      var localName = ol.xml.getLocalName(node);
      goog.asserts.assert(localName == 'Document' || localName == 'Folder',
          'localName should be Document or Folder');
      // FIXME use scope somehow
      var parsersNS = ol.xml.makeStructureNS(
          ol.format.KML.NAMESPACE_URIS_, {
            'Document': ol.xml.makeArrayExtender(this.readDocumentOrFolder_, this),
            'Folder': ol.xml.makeArrayExtender(this.readDocumentOrFolder_, this),
            'Placemark': ol.xml.makeArrayPusher(this.readPlacemark_, this),
            'Style': goog.bind(this.readSharedStyle_, this),
            'StyleMap': goog.bind(this.readSharedStyleMap_, this)
          });
      var features = ol.xml.pushParseAndPop(/** @type {Array.<ol.Feature>} */ ([]),
          parsersNS, node, objectStack, this);
      Eif (features) {
        return features;
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     * @return {ol.Feature|undefined} Feature.
     */
    ol.format.KML.prototype.readPlacemark_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'Placemark',
          'localName should be Placemark');
      var object = ol.xml.pushParseAndPop({'geometry': null},
          ol.format.KML.PLACEMARK_PARSERS_, node, objectStack);
      Iif (!object) {
        return undefined;
      }
      var feature = new ol.Feature();
      var id = node.getAttribute('id');
      if (id !== null) {
        feature.setId(id);
      }
      var options = /** @type {olx.format.ReadOptions} */ (objectStack[0]);

      var geometry = object['geometry'];
      if (geometry) {
        ol.format.Feature.transformWithOptions(geometry, false, options);
      }
      feature.setGeometry(geometry);
      delete object['geometry'];

      Eif (this.extractStyles_) {
        var style = object['Style'];
        var styleUrl = object['styleUrl'];
        var styleFunction = ol.format.KML.createFeatureStyleFunction_(
            style, styleUrl, this.defaultStyle_, this.sharedStyles_,
            this.showPointNames_);
        feature.setStyle(styleFunction);
      }
      delete object['Style'];
      // we do not remove the styleUrl property from the object, so it
      // gets stored on feature when setProperties is called

      feature.setProperties(object);

      return feature;
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.prototype.readSharedStyle_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'Style', 'localName should be Style');
      var id = node.getAttribute('id');
      Eif (id !== null) {
        var style = ol.format.KML.readStyle_(node, objectStack);
        Eif (style) {
          var styleUri;
          Iif (node.baseURI) {
            styleUri = goog.Uri.resolve(node.baseURI, '#' + id).toString();
          } else {
            styleUri = '#' + id;
          }
          this.sharedStyles_[styleUri] = style;
        }
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.prototype.readSharedStyleMap_ = function(node, objectStack) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      goog.asserts.assert(node.localName == 'StyleMap',
          'localName should be StyleMap');
      var id = node.getAttribute('id');
      Iif (id === null) {
        return;
      }
      var styleMapValue = ol.format.KML.readStyleMapValue_(node, objectStack);
      Iif (!styleMapValue) {
        return;
      }
      var styleUri;
      Iif (node.baseURI) {
        styleUri = goog.Uri.resolve(node.baseURI, '#' + id).toString();
      } else {
        styleUri = '#' + id;
      }
      this.sharedStyles_[styleUri] = styleMapValue;
    };

    /**
     * Read the first feature from a KML source.
     *
     * @function
     * @param {Document|Node|Object|string} source Source.
     * @param {olx.format.ReadOptions=} opt_options Read options.
     * @return {ol.Feature} Feature.
     * @api stable
     */
    ol.format.KML.prototype.readFeature;

    /**
     * @inheritDoc
     */
    ol.format.KML.prototype.readFeatureFromNode = function(node, opt_options) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      if (!ol.array.includes(ol.format.KML.NAMESPACE_URIS_, node.namespaceURI)) {
        return null;
      }
      goog.asserts.assert(node.localName == 'Placemark',
          'localName should be Placemark');
      var feature = this.readPlacemark_(
          node, [this.getReadOptions(node, opt_options)]);
      if (feature) {
        return feature;
      } else {
        return null;
      }
    };

    /**
     * Read all features from a KML source.
     *
     * @function
     * @param {Document|Node|Object|string} source Source.
     * @param {olx.format.ReadOptions=} opt_options Read options.
     * @return {Array.<ol.Feature>} Features.
     * @api stable
     */
    ol.format.KML.prototype.readFeatures;

    /**
     * @inheritDoc
     */
    ol.format.KML.prototype.readFeaturesFromNode = function(node, opt_options) {
      goog.asserts.assert(node.nodeType == goog.dom.NodeType.ELEMENT,
          'node.nodeType should be ELEMENT');
      if (!ol.array.includes(ol.format.KML.NAMESPACE_URIS_, node.namespaceURI)) {
        return [];
      }
      var features;
      var localName = ol.xml.getLocalName(node);
      if (localName == 'Document' || localName == 'Folder') {
        features = this.readDocumentOrFolder_(
            node, [this.getReadOptions(node, opt_options)]);
        Eif (features) {
          return features;
        } else {
          return [];
        }
      } else if (localName == 'Placemark') {
        var feature = this.readPlacemark_(
            node, [this.getReadOptions(node, opt_options)]);
        Eif (feature) {
          return [feature];
        } else {
          return [];
        }
      } else if (localName == 'kml') {
        features = [];
        var n;
        for (n = node.firstElementChild; n; n = n.nextElementSibling) {
          var fs = this.readFeaturesFromNode(n, opt_options);
          Eif (fs) {
            goog.array.extend(features, fs);
          }
        }
        return features;
      } else {
        return [];
      }
    };

    /**
     * Read the name of the KML.
     *
     * @param {Document|Node|string} source Souce.
     * @return {string|undefined} Name.
     * @api stable
     */
    ol.format.KML.prototype.readName = function(source) {
      Iif (ol.xml.isDocument(source)) {
        return this.readNameFromDocument(/** @type {Document} */ (source));
      } else Iif (ol.xml.isNode(source)) {
        return this.readNameFromNode(/** @type {Node} */ (source));
      } else Eif (goog.isString(source)) {
        var doc = ol.xml.parse(source);
        return this.readNameFromDocument(doc);
      } else {
        goog.asserts.fail('Unknown type for source');
        return undefined;
      }
    };

    /**
     * @param {Document} doc Document.
     * @return {string|undefined} Name.
     */
    ol.format.KML.prototype.readNameFromDocument = function(doc) {
      var n;
      for (n = doc.firstChild; n; n = n.nextSibling) {
        Eif (n.nodeType == goog.dom.NodeType.ELEMENT) {
          var name = this.readNameFromNode(n);
          if (name) {
            return name;
          }
        }
      }
      return undefined;
    };

    /**
     * @param {Node} node Node.
     * @return {string|undefined} Name.
     */
    ol.format.KML.prototype.readNameFromNode = function(node) {
      var n;
      for (n = node.firstElementChild; n; n = n.nextElementSibling) {
        if (ol.array.includes(ol.format.KML.NAMESPACE_URIS_, n.namespaceURI) &&
            n.localName == 'name') {
          return ol.format.XSD.readString(n);
        }
      }
      for (n = node.firstElementChild; n; n = n.nextElementSibling) {
        var localName = ol.xml.getLocalName(n);
        Eif (ol.array.includes(ol.format.KML.NAMESPACE_URIS_, n.namespaceURI) &&
            (localName == 'Document' ||
             localName == 'Folder' ||
             localName == 'Placemark' ||
             localName == 'kml')) {
          var name = this.readNameFromNode(n);
          if (name) {
            return name;
          }
        }
      }
      return undefined;
    };

    /**
     * Read the network links of the KML.
     *
     * @param {Document|Node|string} source Source.
     * @return {Array.<Object>} Network links.
     * @api
     */
    ol.format.KML.prototype.readNetworkLinks = function(source) {
      var networkLinks = [];
      Iif (ol.xml.isDocument(source)) {
        goog.array.extend(networkLinks, this.readNetworkLinksFromDocument(
            /** @type {Document} */ (source)));
      } else Iif (ol.xml.isNode(source)) {
        goog.array.extend(networkLinks, this.readNetworkLinksFromNode(
            /** @type {Node} */ (source)));
      } else Eif (goog.isString(source)) {
        var doc = ol.xml.parse(source);
        goog.array.extend(networkLinks, this.readNetworkLinksFromDocument(doc));
      } else {
        goog.asserts.fail('unknown type for source');
      }
      return networkLinks;
    };

    /**
     * @param {Document} doc Document.
     * @return {Array.<Object>} Network links.
     */
    ol.format.KML.prototype.readNetworkLinksFromDocument = function(doc) {
      var n, networkLinks = [];
      for (n = doc.firstChild; n; n = n.nextSibling) {
        Eif (n.nodeType == goog.dom.NodeType.ELEMENT) {
          goog.array.extend(networkLinks, this.readNetworkLinksFromNode(n));
        }
      }
      return networkLinks;
    };

    /**
     * @param {Node} node Node.
     * @return {Array.<Object>} Network links.
     */
    ol.format.KML.prototype.readNetworkLinksFromNode = function(node) {
      var n, networkLinks = [];
      for (n = node.firstElementChild; n; n = n.nextElementSibling) {
        if (ol.array.includes(ol.format.KML.NAMESPACE_URIS_, n.namespaceURI) &&
            n.localName == 'NetworkLink') {
          var obj = ol.xml.pushParseAndPop({}, ol.format.KML.NETWORK_LINK_PARSERS_,
              n, []);
          networkLinks.push(obj);
        }
      }
      for (n = node.firstElementChild; n; n = n.nextElementSibling) {
        var localName = ol.xml.getLocalName(n);
        if (ol.array.includes(ol.format.KML.NAMESPACE_URIS_, n.namespaceURI) &&
            (localName == 'Document' ||
             localName == 'Folder' ||
             localName == 'kml')) {
          goog.array.extend(networkLinks, this.readNetworkLinksFromNode(n));
        }
      }
      return networkLinks;
    };

    /**
     * Read the projection from a KML source.
     *
     * @function
     * @param {Document|Node|Object|string} source Source.
     * @return {ol.proj.Projection} Projection.
     * @api stable
     */
    ol.format.KML.prototype.readProjection;

    /**
     * @param {Node} node Node to append a TextNode with the color to.
     * @param {ol.Color|string} color Color.
     * @private
     */
    ol.format.KML.writeColorTextNode_ = function(node, color) {
      var rgba = ol.color.asArray(color);
      var opacity = (rgba.length == 4) ? rgba[3] : 1;
      var abgr = [opacity * 255, rgba[2], rgba[1], rgba[0]];
      var i;
      for (i = 0; i < 4; ++i) {
        var hex = parseInt(abgr[i], 10).toString(16);
        abgr[i] = (hex.length == 1) ? '0' + hex : hex;
      }
      ol.format.XSD.writeStringTextNode(node, abgr.join(''));
    };

    /**
     * @param {Node} node Node to append a TextNode with the coordinates to.
     * @param {Array.<number>} coordinates Coordinates.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.writeCoordinatesTextNode_ =
        function(node, coordinates, objectStack) {
      var context = objectStack[objectStack.length - 1];
      goog.asserts.assert(goog.isObject(context), 'context should be an Object');

      var layout = context['layout'];
      var stride = context['stride'];

      var dimension;
      if (layout == ol.geom.GeometryLayout.XY ||
          layout == ol.geom.GeometryLayout.XYM) {
        dimension = 2;
      } else Eif (layout == ol.geom.GeometryLayout.XYZ ||
          layout == ol.geom.GeometryLayout.XYZM) {
        dimension = 3;
      } else {
        goog.asserts.fail('Unknown geometry layout');
      }

      var d, i;
      var ii = coordinates.length;
      var text = '';
      Eif (ii > 0) {
        text += coordinates[0];
        for (d = 1; d < dimension; ++d) {
          text += ',' + coordinates[d];
        }
        for (i = stride; i < ii; i += stride) {
          text += ' ' + coordinates[i];
          for (d = 1; d < dimension; ++d) {
            text += ',' + coordinates[i + d];
          }
        }
      }
      ol.format.XSD.writeStringTextNode(node, text);
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<ol.Feature>} features Features.
     * @param {Array.<*>} objectStack Object stack.
     * @this {ol.format.KML}
     * @private
     */
    ol.format.KML.writeDocument_ = function(node, features, objectStack) {
      var /** @type {ol.xml.NodeStackItem} */ context = {node: node};
      ol.xml.pushSerializeAndPop(context, ol.format.KML.DOCUMENT_SERIALIZERS_,
          ol.format.KML.DOCUMENT_NODE_FACTORY_, features, objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {Object} icon Icon object.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.writeIcon_ = function(node, icon, objectStack) {
      var /** @type {ol.xml.NodeStackItem} */ context = {node: node};
      var parentNode = objectStack[objectStack.length - 1].node;
      var orderedKeys = ol.format.KML.ICON_SEQUENCE_[parentNode.namespaceURI];
      var values = ol.xml.makeSequence(icon, orderedKeys);
      ol.xml.pushSerializeAndPop(context,
          ol.format.KML.ICON_SERIALIZERS_, ol.xml.OBJECT_PROPERTY_NODE_FACTORY,
          values, objectStack, orderedKeys);
      orderedKeys =
          ol.format.KML.ICON_SEQUENCE_[ol.format.KML.GX_NAMESPACE_URIS_[0]];
      values = ol.xml.makeSequence(icon, orderedKeys);
      ol.xml.pushSerializeAndPop(context, ol.format.KML.ICON_SERIALIZERS_,
          ol.format.KML.GX_NODE_FACTORY_, values, objectStack, orderedKeys);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.style.Icon} style Icon style.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.writeIconStyle_ = function(node, style, objectStack) {
      var /** @type {ol.xml.NodeStackItem} */ context = {node: node};
      var properties = {};
      var src = style.getSrc();
      var size = style.getSize();
      var iconImageSize = style.getImageSize();
      var iconProperties = {
        'href': src
      };

      Eif (size) {
        iconProperties['w'] = size[0];
        iconProperties['h'] = size[1];
        var anchor = style.getAnchor(); // top-left
        var origin = style.getOrigin(); // top-left

        Eif (origin && iconImageSize && origin[0] !== 0 && origin[1] !== size[1]) {
          iconProperties['x'] = origin[0];
          iconProperties['y'] = iconImageSize[1] - (origin[1] + size[1]);
        }

        Eif (anchor && anchor[0] !== 0 && anchor[1] !== size[1]) {
          var /** @type {ol.format.KMLVec2_} */ hotSpot = {
            x: anchor[0],
            xunits: ol.style.IconAnchorUnits.PIXELS,
            y: size[1] - anchor[1],
            yunits: ol.style.IconAnchorUnits.PIXELS
          };
          properties['hotSpot'] = hotSpot;
        }
      }

      properties['Icon'] = iconProperties;

      var scale = style.getScale();
      Eif (scale !== 1) {
        properties['scale'] = scale;
      }

      var rotation = style.getRotation();
      Eif (rotation !== 0) {
        properties['heading'] = rotation; // 0-360
      }

      var parentNode = objectStack[objectStack.length - 1].node;
      var orderedKeys = ol.format.KML.ICON_STYLE_SEQUENCE_[parentNode.namespaceURI];
      var values = ol.xml.makeSequence(properties, orderedKeys);
      ol.xml.pushSerializeAndPop(context, ol.format.KML.ICON_STYLE_SERIALIZERS_,
          ol.xml.OBJECT_PROPERTY_NODE_FACTORY, values, objectStack, orderedKeys);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.style.Text} style style.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.writeLabelStyle_ = function(node, style, objectStack) {
      var /** @type {ol.xml.NodeStackItem} */ context = {node: node};
      var properties = {};
      var fill = style.getFill();
      Eif (fill) {
        properties['color'] = fill.getColor();
      }
      var scale = style.getScale();
      Eif (scale && scale !== 1) {
        properties['scale'] = scale;
      }
      var parentNode = objectStack[objectStack.length - 1].node;
      var orderedKeys =
          ol.format.KML.LABEL_STYLE_SEQUENCE_[parentNode.namespaceURI];
      var values = ol.xml.makeSequence(properties, orderedKeys);
      ol.xml.pushSerializeAndPop(context, ol.format.KML.LABEL_STYLE_SERIALIZERS_,
          ol.xml.OBJECT_PROPERTY_NODE_FACTORY, values, objectStack, orderedKeys);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.style.Stroke} style style.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.writeLineStyle_ = function(node, style, objectStack) {
      var /** @type {ol.xml.NodeStackItem} */ context = {node: node};
      var properties = {
        'color': style.getColor(),
        'width': style.getWidth()
      };
      var parentNode = objectStack[objectStack.length - 1].node;
      var orderedKeys = ol.format.KML.LINE_STYLE_SEQUENCE_[parentNode.namespaceURI];
      var values = ol.xml.makeSequence(properties, orderedKeys);
      ol.xml.pushSerializeAndPop(context, ol.format.KML.LINE_STYLE_SERIALIZERS_,
          ol.xml.OBJECT_PROPERTY_NODE_FACTORY, values, objectStack, orderedKeys);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.Geometry} geometry Geometry.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.writeMultiGeometry_ =
        function(node, geometry, objectStack) {
      goog.asserts.assert(
          (geometry instanceof ol.geom.MultiPoint) ||
          (geometry instanceof ol.geom.MultiLineString) ||
          (geometry instanceof ol.geom.MultiPolygon),
          'geometry should be one of: ol.geom.MultiPoint, ' +
          'ol.geom.MultiLineString or ol.geom.MultiPolygon');
      /** @type {ol.xml.NodeStackItem} */
      var context = {node: node};
      var type = geometry.getType();
      /** @type {Array.<ol.geom.Geometry>} */
      var geometries;
      /** @type {function(*, Array.<*>, string=): (Node|undefined)} */
      var factory;
      if (type == ol.geom.GeometryType.MULTI_POINT) {
        geometries =
            (/** @type {ol.geom.MultiPoint} */ (geometry)).getPoints();
        factory = ol.format.KML.POINT_NODE_FACTORY_;
      } else if (type == ol.geom.GeometryType.MULTI_LINE_STRING) {
        geometries =
            (/** @type {ol.geom.MultiLineString} */ (geometry)).getLineStrings();
        factory = ol.format.KML.LINE_STRING_NODE_FACTORY_;
      } else Eif (type == ol.geom.GeometryType.MULTI_POLYGON) {
        geometries =
            (/** @type {ol.geom.MultiPolygon} */ (geometry)).getPolygons();
        factory = ol.format.KML.POLYGON_NODE_FACTORY_;
      } else {
        goog.asserts.fail('Unknown geometry type: ' + type);
      }
      ol.xml.pushSerializeAndPop(context,
          ol.format.KML.MULTI_GEOMETRY_SERIALIZERS_, factory,
          geometries, objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.LinearRing} linearRing Linear ring.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.writeBoundaryIs_ = function(node, linearRing, objectStack) {
      var /** @type {ol.xml.NodeStackItem} */ context = {node: node};
      ol.xml.pushSerializeAndPop(context,
          ol.format.KML.BOUNDARY_IS_SERIALIZERS_,
          ol.format.KML.LINEAR_RING_NODE_FACTORY_, [linearRing], objectStack);
    };

    /**
     * FIXME currently we do serialize arbitrary/custom feature properties
     * (ExtendedData).
     * @param {Node} node Node.
     * @param {ol.Feature} feature Feature.
     * @param {Array.<*>} objectStack Object stack.
     * @this {ol.format.KML}
     * @private
     */
    ol.format.KML.writePlacemark_ = function(node, feature, objectStack) {
      var /** @type {ol.xml.NodeStackItem} */ context = {node: node};

      // set id
      if (feature.getId()) {
        node.setAttribute('id', feature.getId());
      }

      // serialize properties (properties unknown to KML are not serialized)
      var properties = feature.getProperties();

      var styleFunction = feature.getStyleFunction();
      if (styleFunction) {
        // FIXME the styles returned by the style function are supposed to be
        // resolution-independent here
        var styles = styleFunction.call(feature, 0);
        Eif (styles && styles.length > 0) {
          var style = styles[0];
          if (this.writeStyles_) {
            properties['Style'] = styles[0];
          }
          var textStyle = style.getText();
          if (textStyle) {
            properties['name'] = textStyle.getText();
          }
        }
      }
      var parentNode = objectStack[objectStack.length - 1].node;
      var orderedKeys = ol.format.KML.PLACEMARK_SEQUENCE_[parentNode.namespaceURI];
      var values = ol.xml.makeSequence(properties, orderedKeys);
      ol.xml.pushSerializeAndPop(context, ol.format.KML.PLACEMARK_SERIALIZERS_,
          ol.xml.OBJECT_PROPERTY_NODE_FACTORY, values, objectStack, orderedKeys);

      // serialize geometry
      var options = /** @type {olx.format.WriteOptions} */ (objectStack[0]);
      var geometry = feature.getGeometry();
      if (geometry) {
        geometry =
            ol.format.Feature.transformWithOptions(geometry, true, options);
      }
      ol.xml.pushSerializeAndPop(context, ol.format.KML.PLACEMARK_SERIALIZERS_,
          ol.format.KML.GEOMETRY_NODE_FACTORY_, [geometry], objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.SimpleGeometry} geometry Geometry.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.writePrimitiveGeometry_ = function(node, geometry, objectStack) {
      goog.asserts.assert(
          (geometry instanceof ol.geom.Point) ||
          (geometry instanceof ol.geom.LineString) ||
          (geometry instanceof ol.geom.LinearRing),
          'geometry should be one of ol.geom.Point, ol.geom.LineString ' +
          'or ol.geom.LinearRing');
      var flatCoordinates = geometry.getFlatCoordinates();
      var /** @type {ol.xml.NodeStackItem} */ context = {node: node};
      context['layout'] = geometry.getLayout();
      context['stride'] = geometry.getStride();
      ol.xml.pushSerializeAndPop(context,
          ol.format.KML.PRIMITIVE_GEOMETRY_SERIALIZERS_,
          ol.format.KML.COORDINATES_NODE_FACTORY_,
          [flatCoordinates], objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.geom.Polygon} polygon Polygon.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.writePolygon_ = function(node, polygon, objectStack) {
      goog.asserts.assertInstanceof(polygon, ol.geom.Polygon,
          'polygon should be an ol.geom.Polygon');
      var linearRings = polygon.getLinearRings();
      goog.asserts.assert(linearRings.length > 0,
          'linearRings should not be empty');
      var outerRing = linearRings.shift();
      var /** @type {ol.xml.NodeStackItem} */ context = {node: node};
      // inner rings
      ol.xml.pushSerializeAndPop(context,
          ol.format.KML.POLYGON_SERIALIZERS_,
          ol.format.KML.INNER_BOUNDARY_NODE_FACTORY_,
          linearRings, objectStack);
      // outer ring
      ol.xml.pushSerializeAndPop(context,
          ol.format.KML.POLYGON_SERIALIZERS_,
          ol.format.KML.OUTER_BOUNDARY_NODE_FACTORY_,
          [outerRing], objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.style.Fill} style Style.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.writePolyStyle_ = function(node, style, objectStack) {
      var /** @type {ol.xml.NodeStackItem} */ context = {node: node};
      ol.xml.pushSerializeAndPop(context, ol.format.KML.POLY_STYLE_SERIALIZERS_,
          ol.format.KML.COLOR_NODE_FACTORY_, [style.getColor()], objectStack);
    };

    /**
     * @param {Node} node Node to append a TextNode with the scale to.
     * @param {number|undefined} scale Scale.
     * @private
     */
    ol.format.KML.writeScaleTextNode_ = function(node, scale) {
      ol.format.XSD.writeDecimalTextNode(node, scale * scale);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.style.Style} style Style.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.KML.writeStyle_ = function(node, style, objectStack) {
      var /** @type {ol.xml.NodeStackItem} */ context = {node: node};
      var properties = {};
      var fillStyle = style.getFill();
      var strokeStyle = style.getStroke();
      var imageStyle = style.getImage();
      var textStyle = style.getText();
      if (imageStyle) {
        properties['IconStyle'] = imageStyle;
      }
      if (textStyle) {
        properties['LabelStyle'] = textStyle;
      }
      if (strokeStyle) {
        properties['LineStyle'] = strokeStyle;
      }
      if (fillStyle) {
        properties['PolyStyle'] = fillStyle;
      }
      var parentNode = objectStack[objectStack.length - 1].node;
      var orderedKeys = ol.format.KML.STYLE_SEQUENCE_[parentNode.namespaceURI];
      var values = ol.xml.makeSequence(properties, orderedKeys);
      ol.xml.pushSerializeAndPop(context, ol.format.KML.STYLE_SERIALIZERS_,
          ol.xml.OBJECT_PROPERTY_NODE_FACTORY, values, objectStack, orderedKeys);
    };

    /**
     * @param {Node} node Node to append a TextNode with the Vec2 to.
     * @param {ol.format.KMLVec2_} vec2 Vec2.
     * @private
     */
    ol.format.KML.writeVec2_ = function(node, vec2) {
      node.setAttribute('x', vec2.x);
      node.setAttribute('y', vec2.y);
      node.setAttribute('xunits', vec2.xunits);
      node.setAttribute('yunits', vec2.yunits);
    };

    /**
     * @const
     * @type {Object.<string, Array.<string>>}
     * @private
     */
    ol.format.KML.KML_SEQUENCE_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, [
          'Document', 'Placemark'
        ]);

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Serializer>>}
     * @private
     */
    ol.format.KML.KML_SERIALIZERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'Document': ol.xml.makeChildAppender(ol.format.KML.writeDocument_),
          'Placemark': ol.xml.makeChildAppender(ol.format.KML.writePlacemark_)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Serializer>>}
     * @private
     */
    ol.format.KML.DOCUMENT_SERIALIZERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'Placemark': ol.xml.makeChildAppender(ol.format.KML.writePlacemark_)
        });

    /**
     * @const
     * @type {Object.<string, string>}
     * @private
     */
    ol.format.KML.GEOMETRY_TYPE_TO_NODENAME_ = {
      'Point': 'Point',
      'LineString': 'LineString',
      'LinearRing': 'LinearRing',
      'Polygon': 'Polygon',
      'MultiPoint': 'MultiGeometry',
      'MultiLineString': 'MultiGeometry',
      'MultiPolygon': 'MultiGeometry'
    };

    /**
     * @const
     * @type {Object.<string, Array.<string>>}
     * @private
     */
    ol.format.KML.ICON_SEQUENCE_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, [
          'href'
        ],
        ol.xml.makeStructureNS(
            ol.format.KML.GX_NAMESPACE_URIS_, [
              'x', 'y', 'w', 'h'
        ]));

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Serializer>>}
     * @private
     */
    ol.format.KML.ICON_SERIALIZERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'href': ol.xml.makeChildAppender(ol.format.XSD.writeStringTextNode)
        }, ol.xml.makeStructureNS(
            ol.format.KML.GX_NAMESPACE_URIS_, {
              'x': ol.xml.makeChildAppender(ol.format.XSD.writeDecimalTextNode),
              'y': ol.xml.makeChildAppender(ol.format.XSD.writeDecimalTextNode),
              'w': ol.xml.makeChildAppender(ol.format.XSD.writeDecimalTextNode),
              'h': ol.xml.makeChildAppender(ol.format.XSD.writeDecimalTextNode)
            }));

    /**
     * @const
     * @type {Object.<string, Array.<string>>}
     * @private
     */
    ol.format.KML.ICON_STYLE_SEQUENCE_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, [
          'scale', 'heading', 'Icon', 'hotSpot'
        ]);

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Serializer>>}
     * @private
     */
    ol.format.KML.ICON_STYLE_SERIALIZERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'Icon': ol.xml.makeChildAppender(ol.format.KML.writeIcon_),
          'heading': ol.xml.makeChildAppender(ol.format.XSD.writeDecimalTextNode),
          'hotSpot': ol.xml.makeChildAppender(ol.format.KML.writeVec2_),
          'scale': ol.xml.makeChildAppender(ol.format.KML.writeScaleTextNode_)
        });

    /**
     * @const
     * @type {Object.<string, Array.<string>>}
     * @private
     */
    ol.format.KML.LABEL_STYLE_SEQUENCE_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, [
          'color', 'scale'
        ]);

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Serializer>>}
     * @private
     */
    ol.format.KML.LABEL_STYLE_SERIALIZERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'color': ol.xml.makeChildAppender(ol.format.KML.writeColorTextNode_),
          'scale': ol.xml.makeChildAppender(ol.format.KML.writeScaleTextNode_)
        });

    /**
     * @const
     * @type {Object.<string, Array.<string>>}
     * @private
     */
    ol.format.KML.LINE_STYLE_SEQUENCE_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, [
          'color', 'width'
        ]);

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Serializer>>}
     * @private
     */
    ol.format.KML.LINE_STYLE_SERIALIZERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'color': ol.xml.makeChildAppender(ol.format.KML.writeColorTextNode_),
          'width': ol.xml.makeChildAppender(ol.format.XSD.writeDecimalTextNode)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Serializer>>}
     * @private
     */
    ol.format.KML.BOUNDARY_IS_SERIALIZERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'LinearRing': ol.xml.makeChildAppender(
              ol.format.KML.writePrimitiveGeometry_)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Serializer>>}
     * @private
     */
    ol.format.KML.MULTI_GEOMETRY_SERIALIZERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'LineString': ol.xml.makeChildAppender(
              ol.format.KML.writePrimitiveGeometry_),
          'Point': ol.xml.makeChildAppender(
              ol.format.KML.writePrimitiveGeometry_),
          'Polygon': ol.xml.makeChildAppender(ol.format.KML.writePolygon_)
        });

    /**
     * @const
     * @type {Object.<string, Array.<string>>}
     * @private
     */
    ol.format.KML.PLACEMARK_SEQUENCE_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, [
          'name', 'open', 'visibility', 'address', 'phoneNumber', 'description',
          'styleUrl', 'Style'
        ]);

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Serializer>>}
     * @private
     */
    ol.format.KML.PLACEMARK_SERIALIZERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'MultiGeometry': ol.xml.makeChildAppender(
              ol.format.KML.writeMultiGeometry_),
          'LineString': ol.xml.makeChildAppender(
              ol.format.KML.writePrimitiveGeometry_),
          'LinearRing': ol.xml.makeChildAppender(
              ol.format.KML.writePrimitiveGeometry_),
          'Point': ol.xml.makeChildAppender(
              ol.format.KML.writePrimitiveGeometry_),
          'Polygon': ol.xml.makeChildAppender(ol.format.KML.writePolygon_),
          'Style': ol.xml.makeChildAppender(ol.format.KML.writeStyle_),
          'address': ol.xml.makeChildAppender(ol.format.XSD.writeStringTextNode),
          'description': ol.xml.makeChildAppender(
              ol.format.XSD.writeStringTextNode),
          'name': ol.xml.makeChildAppender(ol.format.XSD.writeStringTextNode),
          'open': ol.xml.makeChildAppender(ol.format.XSD.writeBooleanTextNode),
          'phoneNumber': ol.xml.makeChildAppender(
              ol.format.XSD.writeStringTextNode),
          'styleUrl': ol.xml.makeChildAppender(ol.format.XSD.writeStringTextNode),
          'visibility': ol.xml.makeChildAppender(
              ol.format.XSD.writeBooleanTextNode)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Serializer>>}
     * @private
     */
    ol.format.KML.PRIMITIVE_GEOMETRY_SERIALIZERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'coordinates': ol.xml.makeChildAppender(
              ol.format.KML.writeCoordinatesTextNode_)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Serializer>>}
     * @private
     */
    ol.format.KML.POLYGON_SERIALIZERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'outerBoundaryIs': ol.xml.makeChildAppender(
              ol.format.KML.writeBoundaryIs_),
          'innerBoundaryIs': ol.xml.makeChildAppender(
              ol.format.KML.writeBoundaryIs_)
        });

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Serializer>>}
     * @private
     */
    ol.format.KML.POLY_STYLE_SERIALIZERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'color': ol.xml.makeChildAppender(ol.format.KML.writeColorTextNode_)
        });

    /**
     * @const
     * @type {Object.<string, Array.<string>>}
     * @private
     */
    ol.format.KML.STYLE_SEQUENCE_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, [
          'IconStyle', 'LabelStyle', 'LineStyle', 'PolyStyle'
        ]);

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.xml.Serializer>>}
     * @private
     */
    ol.format.KML.STYLE_SERIALIZERS_ = ol.xml.makeStructureNS(
        ol.format.KML.NAMESPACE_URIS_, {
          'IconStyle': ol.xml.makeChildAppender(ol.format.KML.writeIconStyle_),
          'LabelStyle': ol.xml.makeChildAppender(ol.format.KML.writeLabelStyle_),
          'LineStyle': ol.xml.makeChildAppender(ol.format.KML.writeLineStyle_),
          'PolyStyle': ol.xml.makeChildAppender(ol.format.KML.writePolyStyle_)
        });

    /**
     * @const
     * @param {*} value Value.
     * @param {Array.<*>} objectStack Object stack.
     * @param {string=} opt_nodeName Node name.
     * @return {Node|undefined} Node.
     * @private
     */
    ol.format.KML.GX_NODE_FACTORY_ = function(value, objectStack, opt_nodeName) {
      return ol.xml.createElementNS(ol.format.KML.GX_NAMESPACE_URIS_[0],
          'gx:' + opt_nodeName);
    };

    /**
     * @const
     * @param {*} value Value.
     * @param {Array.<*>} objectStack Object stack.
     * @param {string=} opt_nodeName Node name.
     * @return {Node|undefined} Node.
     * @private
     */
    ol.format.KML.DOCUMENT_NODE_FACTORY_ = function(value, objectStack,
        opt_nodeName) {
      goog.asserts.assertInstanceof(value, ol.Feature,
          'value should be an ol.Feature');
      var parentNode = objectStack[objectStack.length - 1].node;
      goog.asserts.assert(ol.xml.isNode(parentNode),
          'parentNode should be an XML node');
      return ol.xml.createElementNS(parentNode.namespaceURI, 'Placemark');
    };

    /**
     * @const
     * @param {*} value Value.
     * @param {Array.<*>} objectStack Object stack.
     * @param {string=} opt_nodeName Node name.
     * @return {Node|undefined} Node.
     * @private
     */
    ol.format.KML.GEOMETRY_NODE_FACTORY_ = function(value, objectStack,
        opt_nodeName) {
      if (value) {
        goog.asserts.assertInstanceof(value, ol.geom.Geometry,
            'value should be an ol.geom.Geometry');
        var parentNode = objectStack[objectStack.length - 1].node;
        goog.asserts.assert(ol.xml.isNode(parentNode),
            'parentNode should be an XML node');
        return ol.xml.createElementNS(parentNode.namespaceURI,
            ol.format.KML.GEOMETRY_TYPE_TO_NODENAME_[value.getType()]);
      }
    };

    /**
     * A factory for creating coordinates nodes.
     * @const
     * @type {function(*, Array.<*>, string=): (Node|undefined)}
     * @private
     */
    ol.format.KML.COLOR_NODE_FACTORY_ = ol.xml.makeSimpleNodeFactory('color');

    /**
     * A factory for creating coordinates nodes.
     * @const
     * @type {function(*, Array.<*>, string=): (Node|undefined)}
     * @private
     */
    ol.format.KML.COORDINATES_NODE_FACTORY_ =
        ol.xml.makeSimpleNodeFactory('coordinates');

    /**
     * A factory for creating innerBoundaryIs nodes.
     * @const
     * @type {function(*, Array.<*>, string=): (Node|undefined)}
     * @private
     */
    ol.format.KML.INNER_BOUNDARY_NODE_FACTORY_ =
        ol.xml.makeSimpleNodeFactory('innerBoundaryIs');

    /**
     * A factory for creating Point nodes.
     * @const
     * @type {function(*, Array.<*>, string=): (Node|undefined)}
     * @private
     */
    ol.format.KML.POINT_NODE_FACTORY_ =
        ol.xml.makeSimpleNodeFactory('Point');

    /**
     * A factory for creating LineString nodes.
     * @const
     * @type {function(*, Array.<*>, string=): (Node|undefined)}
     * @private
     */
    ol.format.KML.LINE_STRING_NODE_FACTORY_ =
        ol.xml.makeSimpleNodeFactory('LineString');

    /**
     * A factory for creating LinearRing nodes.
     * @const
     * @type {function(*, Array.<*>, string=): (Node|undefined)}
     * @private
     */
    ol.format.KML.LINEAR_RING_NODE_FACTORY_ =
        ol.xml.makeSimpleNodeFactory('LinearRing');

    /**
     * A factory for creating Polygon nodes.
     * @const
     * @type {function(*, Array.<*>, string=): (Node|undefined)}
     * @private
     */
    ol.format.KML.POLYGON_NODE_FACTORY_ =
        ol.xml.makeSimpleNodeFactory('Polygon');

    /**
     * A factory for creating outerBoundaryIs nodes.
     * @const
     * @type {function(*, Array.<*>, string=): (Node|undefined)}
     * @private
     */
    ol.format.KML.OUTER_BOUNDARY_NODE_FACTORY_ =
        ol.xml.makeSimpleNodeFactory('outerBoundaryIs');

    /**
     * Encode an array of features in the KML format.
     *
     * @function
     * @param {Array.<ol.Feature>} features Features.
     * @param {olx.format.WriteOptions=} opt_options Options.
     * @return {string} Result.
     * @api stable
     */
    ol.format.KML.prototype.writeFeatures;

    /**
     * Encode an array of features in the KML format as an XML node.
     *
     * @param {Array.<ol.Feature>} features Features.
     * @param {olx.format.WriteOptions=} opt_options Options.
     * @return {Node} Node.
     * @api
     */
    ol.format.KML.prototype.writeFeaturesNode = function(features, opt_options) {
      opt_options = this.adaptOptions(opt_options);
      var kml = ol.xml.createElementNS(ol.format.KML.NAMESPACE_URIS_[4], 'kml');
      var xmlnsUri = 'http://www.w3.org/2000/xmlns/';
      var xmlSchemaInstanceUri = 'http://www.w3.org/2001/XMLSchema-instance';
      ol.xml.setAttributeNS(kml, xmlnsUri, 'xmlns:gx',
          ol.format.KML.GX_NAMESPACE_URIS_[0]);
      ol.xml.setAttributeNS(kml, xmlnsUri, 'xmlns:xsi', xmlSchemaInstanceUri);
      ol.xml.setAttributeNS(kml, xmlSchemaInstanceUri, 'xsi:schemaLocation',
          ol.format.KML.SCHEMA_LOCATION_);

      var /** @type {ol.xml.NodeStackItem} */ context = {node: kml};
      var properties = {};
      if (features.length > 1) {
        properties['Document'] = features;
      } else Eif (features.length == 1) {
        properties['Placemark'] = features[0];
      }
      var orderedKeys = ol.format.KML.KML_SEQUENCE_[kml.namespaceURI];
      var values = ol.xml.makeSequence(properties, orderedKeys);
      ol.xml.pushSerializeAndPop(context, ol.format.KML.KML_SERIALIZERS_,
          ol.xml.OBJECT_PROPERTY_NODE_FACTORY, values, [opt_options], orderedKeys,
          this);
      return kml;
    };